;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(deffunc wait-thread - Thread-gen
	             (plan procterm - Sexp negterm - (~ Sexp) _ - Typenv)
   (be Thread-gen
      (\\ - Thread-cont (then - Thread-cont)
	 (\\ - TC-val (es - Exec-state stack - Thread-stack)
	    (cond ((eq (!_mode es) ':real)
		   (signal-problem wait-thread
			 "Get real"))
		  (t
		   (let ((sit (!_sit es))
			 (past-sits (<# !_sit (!_hist es))))
		      (let ((succ-sit false) - (~ Situation)
			    (failed false) (forced false) - Boolean
			    (open-subgoal false) - (~ Sexp)
			    ;;;; (steps 0) - Fixnum
			    adds dels al dl - (Lst Occasion)
			    (elapsed 0.0)  - (Alt Time-int (Const *never))
			    (prev-sit (and (not (null past-sits))
					   (car past-sits)))
			    - (~ Situation)
			    frac - Float
			    (dom (!_dom es)) - Domain)
			 (let-fun ()
			    (cond ((process-find procterm sit)
				   (!= < succ-sit adds dels elapsed frac >
				       (process-project-and-record
					  sit (!_sit es) prev-sit
					  procterm negterm (!_sit-space es)
					  dom))
				   (!= failed
				       (or (not succ-sit)
					   (let ((new-pc (!_processes succ-sit)))
					      (and new-pc
						   (not (!_kosher new-pc)))))))
				  (t
				   (!= failed true)
				   (case (!_mode es)
				      (:forced
				       (!= < succ-sit al dl >
					   (process-existence-force
						 plan procterm negterm sit past-sits
						 (!_sit-space es) dom))
				       (cond ((not (process-find procterm succ-sit))
					      (dbg-save :run-loud
						 procterm sit succ-sit dom)
					      (signal-problem wait-thread
						 "Process cannot be forced to"
						 " exist: " procterm)))
				       (!= < succ-sit adds dels elapsed frac >
					   (process-project-and-record
					      succ-sit (!_sit es) prev-sit
					      procterm negterm (!_sit-space es)
					      dom))
				       (!= < adds dels >
					   (add-del-combine al dl adds dels))
				       (!= forced true))
				      (:zero-step
				       (!= open-subgoal 
					   `(process-exists ,procterm ,negterm))))))
			    (cond ((and forced
					(not (eq elapsed '*never))
					(> frac 0.0)
					(< frac 1.0))
				   (!= elapsed (be Time-int
						   (/ (be Time-int elapsed)
						      frac)))))
			    (let ((new-es
				     (note-post-process-changes)))
			       (values
				  (be Exec-status
				      (cond ((or forced open-subgoal)
					     (cond ((null (!_active new-es))
						    (cond (open-subgoal
							   ':continuing)
							  (t ':blocked)))
						   (t ':continuing)))
					    (failed ':failed)
					    (t ':continuing)))
				  new-es))

          :where

;;;; (:def project-found-process ())
;;;;
;;;; (:def project-forced-process ()
;;;;			     )
;;;;
;;;; (:def compute-elapsed-time ()
;;;;		      )

 (:def note-post-process-changes - Exec-state ()
    (let ((elapsed-time
	     (cond ((eq elapsed '*never)
		    (exec-value-get max-time-link* (!_vals es)))
		   (t (be Time-int elapsed))))
	    - Time-int
	  (new-thread (new-Thread then `(after ,plan) stack))
	    - Thread)
       (copy-with-changes es
	    (:vals (exec-value-set
		      forcings-link*
		      !>vals
		      (be * (\\ (fc) (+ fc 1)))
		      false)
	     :active
		(cond ((or (and failed (not forced))
			   open-subgoal)
		       !>active)
		      (t
		       (cons new-thread !>active)))
	     :pp (make Plan-prefix
		    (+ (!_length !>pp) 1)
		    (+ (!_duration !>pp) elapsed-time)
		    (or succ-sit sit)
		    (make Plan-prefix-delta
		       (uniquify-action plan dom)
		       0 elapsed-time !() !>pp))
	     :hist (cons es !>hist)
	     :blocked
	       (cond (open-subgoal
		      (cons (make Blockage
			       (make Gate
				  ':open-subgoals
				  (list (list open-subgoal)))
			       (list new-thread))
			    !>blocked))
		     (t !>blocked)))))))))))))))