;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: continproj.lisp,v 1.16 2005/12/26 22:07:58 dvm Exp $

(depends-on %module/ nisp)

(depends-on :at-run-time %opt/ walkdom)

;;;;;;; The following kludge should not be necessary long-term:
;;;;(eval-when (:load-toplevel)
;;;;   (bind ((*package* (find-package :opt))
;;;;	  (*readtable* (ytools::named-readtable :ytools)))
;;;;      (opt::fload "~/CVSified/prog/opt/" walkdom)))

(depends-on :at-run-time %opt/ deduction index 
	    %optop/ types domain procmod projutil)

(debuggable -1)

(deffunc wait-project - (Multvals
			     succ - (~ Situation)
			     adds deletes - (Lst Occasion)
			     elapsed - (Alt Time-int (Const *never))
			     ;;linkid - (~ Symbol)
			     ;;assumptions - (Lst Sexp)
			     )
	              (allow-anomalies - Boolean
		       sit - Situation sit-space - Situation-space dom - Domain)
   (let ((p (find-old-projection sit 'wait sit-space))
	 - (~ Sitsuccspec))
      (cond (p
;;;;	     (cond ((or (sit-patho (!_sit p))
;;;;			(and watch-sit* (sit-patho watch-sit*)))
;;;;		    (dbg-save p sit)
;;;;		    (signal-problem wait-project
;;;;		       "Pathology from old wait")))
             (values (!_sit p)
		     (!_adds p)
                     (!_deletes p)
		     (!_elapsed p)))
	    (t
	     (fresh-wait-project allow-anomalies sit sit-space dom true)))))

(deffunc fresh-wait-project - (Multvals
				 succ - (~ Situation)
				 adds deletes - (Lst Occasion)
				 elapsed - (Alt Time-int (Const *never)))
	              (allow-anomalies - Boolean
		       sit - Situation 
		       sit-space - Situation-space dom - Domain
		       alter - Boolean)
   (let ((processes (!_processes sit)))
      (cond (processes
	     (multi-let (((next-time effects new-eps)
			  (get-trigger-time processes dom)))
 	        (cond ((eq next-time '*never)
		       (infeas-wait-project sit '*never sit-space alter))
		      (t
;;;;		       (cond ((= new-eps 0.001)
;;;;			      (dbg-save sit next-time effects)
;;;;			      (breakpoint fresh-wait-project
;;;;				 "Eps anomaly at " sit)))
		       (let ((new-sit
			        (new-succ-sit
				    sit (uniquify-action
					   `(wait ,next-time)
					   dom)))
			     (new-vals
				   (<# (\\ (flcm)
					  (tuple (be Uterm (!_fluent flcm))
						 (funcall (!_timefcn flcm)
							  (be Time-int
							     next-time))))
				       (!_model processes))))
			  (assertion-find-and-erase
			     '(process-transition ?w ?p) dummy-id* (empty-env)
			     new-sit)
			  (assertion-find-and-erase
			     '(epsilon-value ?v) dummy-id* (empty-env)
			     new-sit)
			  (assertion-add `(epsilon-value ,new-eps) new-sit dom)
			  (finish-wait-project
			     allow-anomalies next-time
			     sit new-sit dom new-vals effects
			     sit-space alter))))))
	    (t
	     (cond (alter
		    (!= sit
			(succ-create 0 sit 0.0 0 'wait sit !() !() 0.0 !() sit-space))))
	     (values sit !() !() 0.0)))))

(defproc infeas-wait-project - (Multvals
				  succ - (~ Situation)
				  adds deletes - (Lst Occasion)
				  elapsed - (Alt Time-int (Const *never)))
	              (sit - Situation elap - (Alt Time-int (Const *never))
		       sit-space - Situation-space
		       alter - Boolean)
   (cond (alter
	  (succ-create 1 sit elap 0 'wait false !() !() 0.0 !() sit-space)))
   (values false !() !() elap))

;;;;(specdecl new-potential-processes* - (Lst Process-instance))

(deffunc finish-wait-project - (Multvals new-sit - Situation
					 adds dels - (Lst Occasion)
					 elapsed - (Alt Time-int
							(Const *never))
;;;;					 linkid - (~ Symbol)
;;;;					 assumptions - (Lst Sexp)
					 )
	                (allow-anomalies - Boolean
			 elapsed-time - (Alt Time-int (Const *never))
			 old-sit new-sit - Situation dom - Domain
			 new-vals - (Lst (Lrcd Uterm Number))
			 effects - (Lst Sexp)
			 sit-space - Situation-space alter - Boolean)
;;;;   (bind ((new-potential-processes* '())
;;;;	  - (Lst Process-instance)) ...)
      (let ((deletes
	       (nconc
		  (repeat :for ((eff :in effects) d - Sexp)
		   :when (matchq (not ?d) eff)
		   :append (assertion-erase d new-sit dom))
		  (repeat :for ((fl-val :in new-vals))
		   :nconc (assertion-find-and-erase
			     `(current-value
				 ,(!_term (car fl-val))
				 ?_)
			     opt::dummy-id* '() new-sit)
		   :when (matchq (elapsed ?_) (!_term (car fl-val)))
		   :nconc (assertion-find-and-erase
			      `(last-elapsed ,(!_term (car fl-val))
					     ?_)
			      dummy-id* '() new-sit))))
	    (adds
	       (nconc
		  (repeat :for ((eff :in effects))
		   :when (not (matchq (not ?_) eff))
		   :append (assertion-add eff new-sit dom))
		  (repeat :for ((fl-val :in new-vals))
		   :nconc (assertion-add
				 `(current-value
				     ,(!_term (car fl-val))
				     ,(cadr fl-val))
				 new-sit dom))))
	    - (Lst Occasion)
	    ;;;;(forced false) - Boolean
	    )
	 (multi-let (((al dl _ realnew)
		      (setup-process-complex
		         allow-anomalies new-sit !() old-sit
			 elapsed-time sit-space dom)))
	    (!= adds (nconc al *-*))
	    (!= deletes (nconc dl *-*))
	    (!= new-sit realnew))
	 (!= (!_frozen new-sit) true)
	 (cond (alter
		(let ((usucc
		       (succ-record
			  false old-sit elapsed-time 0 'wait new-sit
			  adds deletes 0.0 !() sit-space)))
		   (values usucc adds deletes elapsed-time)))
	       (t
		(values new-sit adds deletes elapsed-time)))))

;;; Called (through sit-init-completer*) in opt/assertion.lisp.
(defproc sit-start-processes - (Fun Void (Initial-situation))
	           (sit-space - Situation-space)
   (\\ - Void (sit - Initial-situation)
;;;;   (out (to *error-output*)
;;;;      "Made it to sit-start-processes" :%)
      (let ((sitdom (!_domain sit))
	    (all-process-defns (make (Collector Process-defn))))
	 (repeat :for ((anc :in (!_ancestors sitdom)))
	    (domain-prepare-for-planning anc))
	 (walk-domain-bdgs
	    sitdom
	    (\\ (bdg - Domain-bdg _ - Opt-domain)
	       (let ((v (!_val bdg)))
		  (cond ((is Causation-function v)
			 (let ((defn (!_defn v)))
			    ;; This is probably unnecessary in general;
			    ;; inserted for debugging purposes --
			    (!= (!_internalized defn) false)
			    (cond ((or (is Process-defn defn)
				       (is Durative-action-defn defn))
				   (one-collect all-process-defns defn)))))))))
	 (!= (!_process-defns sit)
	     (!_elements all-process-defns))
	 (!= sitdom (domain-prepare-for-planning *-*))
	 (domain-make-current sitdom)
	 (multi-let (((_ _ kosher actual-init-sit)
		      (setup-process-complex false sit !() false 0.0 sit-space sitdom)))
            (declare (ignorable kosher))
;;;;	    (cond ((not kosher)
;;;;		   (signal-problem sit-start-processes
;;;;		      "Inconsistency in initial process configuration")))
	    (cond ((not (eq actual-init-sit sit))
		   (succ-record
			       false sit 0.0 0
			       'actual-init
			       actual-init-sit
			       !() !() 1.0 !() sit-space)))
;;;;	    (cond ((!_processes actual-init-sit)
;;;;		   (out "Checking for time-passing "
;;;;			(!_active (!_processes actual-init-sit)) :%)))
	    (cond ((and (!_processes actual-init-sit)
			(exists (pinst :in (!_active (!_processes actual-init-sit)))
			   (equal (!_term (!_uterm pinst))
				  '(time-passing))))
;;;;		   (out "Setting the clock" :%)
		   (assertion-add '(current-value clock 0.0)
				  actual-init-sit sitdom)))))))

;;;;		;;;(dbg-save :run-loud actual-init-sit sit)
;;;;		(signal-problem sit-start-processes :fatal
;;;;		   "Situation discrepancy"))))))

;;;; (!= sit-init-completer* #'sit-start-processes)

(specdecl (note-transition-sits* false) - Boolean
	  ;; -- if true, record process-transition situations for
	  ;; debugging purposes
	  (transition-num* 0) - Integer
;;;;	  (bad-news* false)
;;;;	  - Boolean
	  )

(defproc setup-process-complex - (Multvals adds deletes - (Lst Occasion)
					   clean - Boolean
					   actual-new-sit - Situation)
	                       (allow-anomalies - Boolean
				new-sit - Situation
				new-process-instances - (Lst Process-instance)
				old-sit - (~ Situation)
				elapsed-between - (Alt Time-int (Const *never))
				sit-space - Situation-space dom - Domain)
			       (ignore elapsed-between)
   ;; new-sit is initially unfrozen and unrecorded.  Caller will freeze
   ;; and record the actual-new-sit that we return.  Transitional
   ;; situations produced en route are frozen but not recorded (because
   ;; they don't have kosher process complexes set up).
  (let ()
     (cond (old-sit
	    (cond ((not (!_processes old-sit))
		   (signal-problem setup-process-complex
		      "Process transition blocked by absence of"
		      " process-complex in " old-sit)))))
     ;; Each iteration is an attempt to reach quiescence, that is, a
     ;; a state in which the stopping or starting of a process does
     ;; not trigger the stopping or starting of another process.
     (repeat :for ((i = 0 :by 1) - Fixnum
		   (old-active
		      (cond (old-sit (!_active (!_processes old-sit)))
			    (t !())))
		   (new-active !())
                   (new-dormant !())
                   (starting !())
                   (stopping !())
		   (all-starters new-process-instances)
		   (all-stoppers !())
		   - (Lst Process-instance)
		   (actual-new-sit new-sit) - Situation
		   (adds !()) (deletes !()) al dl - (Lst Occasion)
		   processes-stabilized - Boolean)
	(!= < starting stopping new-active
	      al dl actual-new-sit >
	    (process-transition-sit new-sit old-active dom))
	(!= < adds deletes >
	    (add-del-combine adds deletes al dl))
	(!= processes-stabilized
	    (and (null starting) (null stopping)))
	(cond (old-sit (!= (!_frozen old-sit) true)))
	(cond (note-transition-sits*
	       (cond ((eq new-sit actual-new-sit)
		      (cond ((not (and (null starting)
				       (null stopping)))
			     (dbg-save :run-loud starting stopping
						 new-sit actual-new-sit)
			     (signal-problem setup-process-complex
				"Self transition with"
				:% " starting = " starting
				:% " stopping = " stopping
				:proceed))))
		     (t
		      (cond ((and (null starting) (null stopping))
			     (dbg-save :run-loud new-sit actual-new-sit)
			     (signal-problem setup-process-complex
				"Process transition with no processes"
				" starting or stopping"
				:proceed)))
		      (transition-succ-record
			 new-sit actual-new-sit al dl sit-space dom)
;;;;		      (cond ((or (sit-patho actual-new-sit)
;;;;				 (and watch-sit* (sit-patho watch-sit*)))
;;;;			     (dbg-save new-sit actual-new-sit)
;;;;			     (signal-problem setup-process-complex
;;;;				"Pathology after transition-succ-record")))
		      ))))
      :while (and (not processes-stabilized)
		  (not (exists (a :in starting)
			  (proc-inst-in-list a all-stoppers)))
		  (not (exists (o :in stopping)
			  (proc-inst-in-list o all-starters))))
	   (!= old-active new-active)
	   (!= old-sit new-sit)
	   (!= new-sit actual-new-sit)
	   (!= all-starters (append starting *-*))
	   (!= all-stoppers (append stopping *-*))
      :result
	 (progn
	    (check-for-anomalies)
;;;;	    (out "Anomalies checked" :%)
;;;;	    (cond ((null new-active)
;;;;		   (dbg-save new-dormant actual-new-sit dom)
;;;;		   (breakpoint setup-process-complex
;;;;		      "Setting up uninteresting process model")))
	    (multi-let (((model kosher triggers)
			 (construct-process-model
			     new-active new-dormant
			     actual-new-sit dom)))
;;;;               (cond ((and (not model) (not kosher))
;;;;                      (dbg-save triggers new-active new-dormant
;;;;                                actual-new-sit dom)
;;;;                      (breakpoint setup-process-complex
;;;;                         "Bad result (?) from construct-process-model")))
	       (!= (!_processes actual-new-sit)
		   (make Process-complex
			 new-active new-dormant
			 '*unknown
			 model
			 (be (Lst Ineq-trigger)
			     (<? is Ineq-trigger triggers))
			 (and kosher processes-stabilized)))
	       (values adds deletes
		       (and kosher processes-stabilized)
		       actual-new-sit)))
	 
      :where
         (:def check-for-anomalies - Void ()
	    (cond ((not processes-stabilized)
		   (let ((stop-start
			    (repeat :for ((prin :in starting))
			     :when (proc-inst-in-list prin all-stoppers)
			     :collect prin))
			 (start-stop
			    (repeat :for ((prin :in stopping))
			       :when (proc-inst-in-list prin all-starters)
			       :collect prin)))
		      (cond (allow-anomalies
			     (dbg-out forceproj-dbg*
				"Stuttering"
				:% "Stopped, then started: " stop-start
				:% "Started, then stopped: " start-stop))
			    (t
			     (dbg-save :run-loud starting stopping old-active
				       new-active new-dormant)
			     (signal-problem setup-process-complex
				"Stuttering"
				:% "Stopped, then started: " stop-start
				:% "Started, then stopped: " start-stop
			       (:proceed !"Situation will stand ~
                                            as of mid-stutter"))))))
		  ((not (null (intersection adds deletes)))
		   (let ((bogosities (intersection adds deletes)))
		      (cond (allow-anomalies
			     (dbg-out forceproj-dbg*
				"Assertion(s) added and deleted by"
				" process transition: "
				:% bogosities))
			    (t
			     (dbg-save :run-loud bogosities new-sit
				       actual-new-sit)
			     (signal-problem setup-process-complex
				"Assertion(s) added and deleted by"
				" process transition: "
				:% bogosities
				:proceed))))))))))

(specdecl ;;;;trans-sit* - Situation
	  (stop-if-loading* false) - Boolean)

(defproc process-transition-sit  - (Multvals starting stopping new-active
					     - (Lst Process-instance)
					     adds deletes - (Lst Occasion)
					     actual-new-sit - Situation)
	              (new-sit - Situation
		       prev-active - (Lst Process-instance) dom - Domain)
   (let ((init (find-init-situation new-sit)))
      (repeat :for ((proc :in (!_process-defns init))
		       - (Alt Process-defn Durative-action-defn)
		    (proc-i = 1 :by 1) - Fixnum
		    (living !(Process-instance))
		    stopping starting new-active
		       - (Lst Process-instance))
	 (let ((intprocdef
		  (be Internalized-process-defn
		      (causation-view
			      proc #'durative-process-view
			      dom))))
	    (repeat :for ((c :in (!_sorted-condition intprocdef)))
	       (repeat :for ((pinst :in (process-instantiate-potentials
					   (!_discrete c) (!_continuous c)
					   (new-Varid) !() new-sit
					   intprocdef dom)))
		  (repeat :for ((lp :in living))
		   :result (!= living (cons pinst *-*))
		   :until (eq (!_uterm lp) (!_uterm pinst))
		   :result (!= (!_continuous lp)
			       (append (!_continuous pinst)
				       *-*)))))
	    )
       :result 
	 (progn
	    (!= < new-active _ > 
		(classify
		   living
		   (\\ (pinst - Process-instance)
		      (process-instance-active pinst new-sit dom))))
	    (!= < starting stopping >
		(find-process-transitions
		   prev-active new-active))
	    (cond ((and (null starting) (null stopping))
		   (values !() !() new-active !() !() new-sit))
		  (t
		   (!= (!_frozen new-sit) true)
		   ;;;;(!= trans-sit* new-sit)
		   (let ((actual-new-sit
			    (new-succ-sit
			       new-sit
			       (uniquify-action
				  `(transition
				      (start-stop
				         (stops ,(<# !_term stopping))
					 (starts ,(<# !_term starting))))
				  dom)))
			 - Situation
			 (adds !()) (deletes !()) - (Lst Occasion))
		      (repeat :for ((a :in starting))
			 (assertion-add
			    `(process-transition starting ,(!_term a))
			     actual-new-sit dom))
		      (repeat :for ((a :in stopping))
			 (assertion-add
			    `(process-transition stopping ,(!_term a))
			     actual-new-sit dom))
		      (letrec ((do-process-effects
				       (processes
					- (Lst Process-instance)
					eff - (Fun Sexp (Process-instance)))
;;;;				  (dbg-save processes eff)
;;;;				  (breakpoint process-transition-sit
;;;;				     "Effects = "
;;;;				     (<# (\\ (p) (funcall eff p))
;;;;					 processes))
				  (repeat :for ((proc-inst :in processes))
				     (multi-let (((al dl)
						  (process-sit-change
						     (funcall eff proc-inst)
						     new-sit actual-new-sit
						     dom)))
					(!= adds (union al *-*))
					(!= deletes (union dl *-*))))))
			 (do-process-effects
			     stopping (\\ (i - Process-instance)
					 (!_stop-effect i)))
;;;;			 (cond ((pathological)
;;;;				(dbg-save new-sit stopping)
;;;;				(signal-problem process-transition-sit
;;;;				   "Pathology after processing stopping"
;;;;				   " processes " stopping)))
			 (do-process-effects
			     starting (\\ (i - Process-instance)
					 (!_start-effect i)))
;;;;			 (cond ((pathological)
;;;;				(dbg-save new-sit starting)
;;;;				(signal-problem process-transition-sit
;;;;				   "Pathology after processing starting"
;;;;				   " processes " starting)))
			 (multi-let (((al dl)
				      (processes-elapsed-reset
					  stopping starting
					  actual-new-sit dom)))
			    (!= adds (union al *-*))
			    (!= deletes (union dl *-*)))
			 (do-process-effects
			     new-active (\\ (i - Process-instance)
					   (!_effect i)))
			 )
;;;;		      (cond ((or (sit-patho new-sit)
;;;;				 (and watch-sit* (sit-patho watch-sit*)))
;;;;			     (dbg-save new-sit)
;;;;			     (signal-problem process-transition-sit
;;;;				"Pathology when returning from process-transition-sit")))
		      (cond ((and (null adds) (null deletes))
			     (values starting stopping new-active
				     !() !() new-sit))
			    (t
			     (values starting stopping new-active
				     adds deletes actual-new-sit)))))))
       :where
;;;;          (pathological - Boolean ()
;;;;	     (or (sit-patho new-sit)
;;;;		 (and watch-sit* (sit-patho watch-sit*))))
	  )))

(deffunc active-process-instances - (Lst Process-instance)
	                          (intprocdef - Internalized-process-defn
				   already - (Lst Process-instance)
				   new-sit - Situation dom - Domain)
	    (repeat :for ((c :in (!_sorted-condition intprocdef)))
	       (repeat :for ((pinst :in (process-instantiate-potentials
					   (!_discrete c) (!_continuous c)
					   (new-Varid) !() new-sit
					   intprocdef dom)))
		  (repeat :for ((lp :in already))
		   :result (!= already (cons pinst *-*))
		   :until (eq (!_uterm lp) (!_uterm pinst))
		   :result (!= (!_continuous lp)
			       (append (!_continuous pinst)
				       *-*))))))

(specdecl yt::+unbound-slot-val+ - Symbol)

(deffunc process-instantiate-potentials - (Lst Process-instance)
	                 (discrete-conds - (Lst Sexp)
			  continuous-conds - (Lst (Lst Sexp))
			  id - Varid bdgs - Bdgenv sit - Situation 
			  pdefn - Internalized-process-defn
			  dom - Domain)
   (repeat :for ((a :in (deduce `(and ,@discrete-conds) id bdgs sit dom)))
;;;;      (dbg-save a discrete-conds id bdgs)
;;;;      (breakpoint process-instantiate-potentials
;;;;	 "got a = " a
;;;;	 t " for " discrete-conds)
    :collect
      (multi-let ((pterm (varsubst-to-constant (!_term pdefn) id a))
		  ((l - Sexp env - Bdgenv)
		   (safe-varsubst (list (!_start-effect pdefn)
					(!_effect pdefn)
					(!_stop-effect pdefn))
				  id a)))
		 (ignore env)
	  (let (start-effect effect stop-effect - Sexp)
	     (!= (< start-effect effect stop-effect >)
		 (be * l))
	     (cond ((eq start-effect yt::+unbound-slot-val+)
		    (dbg-save effect stop-effect pdefn l id a)
		    (breakpoint process-instantiate-potentials
		       "Got bogus start-effect")))
;;;;	     (out (:to *error-output*)
;;;;		"New process-instance: "
;;;;		(uniquify-occasion pterm dom)
;;;;		:% "Discrete: " (debug-varsubst discrete-conds id a)
;;;;		:% "Continuous: " (debug-varsubst continuous-conds id a)
;;;;		:% "Start effect: " start-effect
;;;;		:% "Stop effect: " stop-effect
;;;;		:%)
;;;;	     (cond ((or (eq start-effect 'true) (eq stop-effect 'true))
;;;;		    (dbg-save pdefn id a)
;;;;		    (breakpoint process-instantiate-potentials
;;;;		       "Odd effects of " pdefn)))
	     (make Process-instance
		   (uniquify-occasion pterm dom)
		   (<# (\\ (dc) (varsubst-to-constant dc id a))
		       discrete-conds)
		   (<# (\\ (ccl)
			  (<# (\\ (cc)
				 (continuous-cond-varsubst
				    cc id a dom))
			      ccl))
		       continuous-conds)
		   start-effect effect stop-effect)))))

(defproc transition-succ-record - Void (prev-sit trans-sit - Situation
					adds deletes - (Lst Occasion)
					sit-space - Situation-space dom - Domain)
   (cond ((not (!_frozen trans-sit))
	  ;; Make sure trans-sit is truly unique
	  (!= transition-num* (+ *-* 1))
	  (assertion-add `(succ-unique ,transition-num*)
			 trans-sit dom)))
   (succ-record false prev-sit 0.0 0 (car (!_path trans-sit))
		trans-sit adds deletes 0.0 !() sit-space))

(deffunc continuous-cond-varsubst - Uterm-ineq
	                     (cc - Sexp id - Varid bdgs - Bdgenv dom - Domain)
   (ineq->uterm-ineq (varsubst-to-constant cc id bdgs)
		     dom))

(deffunc ineq->uterm-ineq - Uterm-ineq (cc - Sexp dom - Domain)
   (match-cond cc
      ?( (?ineq ?q1 ?q2)
	(cond ((memq ineq ineq-rels*)
	       (tuple (be (Const < =< >= >) ineq)
		      (uniquify-continuous-fluent-subterms q1 dom)
		      (uniquify-continuous-fluent-subterms q2 dom)))
	      (t
	       (signal-problem continuous-cond-internalize :fatal
		  "Not a legal inequality: " cc))))
      (t
       (signal-problem continuous-cond-varsubst
	  "Unintelligible continuous condition: " cc))))

(deffunc process-instance-active - Boolean
	                        (pinst - Process-instance
				 sit - Situation dom - Domain)
   (cond ((deducible `(process-transition starting ,(!_term (!_uterm pinst)))
		     ground-id* (empty-env) sit dom)
	  true)
	 ((deducible `(process-transition stopping ,(!_term (!_uterm pinst)))
		     ground-id* (empty-env) sit dom)
	  false)
	 (t
	  (exists (d :in (!_continuous pinst))
	     (forall (c :in d)
		     - Uterm-ineq
		(deducible
			(uterm-exp->fl-sexp c)
			ground-id* !()
			sit dom))))))

(deffunc find-process-transitions - (Multvals starting stopping
					      - (Lst Process-instance))
	                  (old-active new-active - (Lst Process-instance))
   (letrec ()
      (values
	 (repeat :for ((new :in new-active) - Process-instance
		       (starting !()) - (Lst Process-instance))
	    (cond ((and (absent-in new old-active)
			(absent-in new starting))
		   (!= starting (cons new *-*))))
	  :result starting)
	 (repeat :for ((old :in old-active) - Process-instance
		       (stopping !()) - (Lst Process-instance))
	    (cond ((and (absent-in old new-active)
			(absent-in old stopping))
		   (!= stopping (cons old *-*))))
	  :result stopping))
	 
    :where
       (absent-in - Boolean (p - Process-instance pl - (Lst Process-instance))
	  (not (proc-inst-in-list p pl)))))

(defproc process-sit-change - (Multvals adds deletes - (Lst Occasion))
	                    (eff - (~ Sexp) old-sit new-sit - Situation
			     dom - Domain)
   (cond (eff
	  (letrec ()
	     (multi-let (((adds deletes)
			  (deduce-effects eff eff-varid* (empty-env)
					  old-sit dom)))

;;;;		(cond ((pathological)
;;;;		       (dbg-save old-sit new-sit eff adds deletes)
;;;;		       (signal-problem process-sit-change
;;;;			  "Pathology after deduce-effects")))
		(cond ((not (and (null adds) (null deletes)))
		       (delete-and-add adds deletes eff-varid* (empty-env)
				       new-sit dom)
;;;;		       (cond ((pathological)
;;;;			      (dbg-save old-sit new-sit adds deletes)
;;;;			      (signal-problem process-sit-change
;;;;				 "Pathology after delete-and-add")))
		       (values adds deletes))
		      (t (values !() !()))))
	   :where
;;;;	      (pathological - Boolean ()
;;;;		 (or (sit-patho old-sit)
;;;;		     (sit-patho new-sit)
;;;;		     (and watch-sit* (sit-patho watch-sit*))))
	      ))
	 (t (values !() !()))))

(specdecl (ua-id* (new-Varid)) - Varid)

(defproc processes-elapsed-reset - (Multvals eladds eldels - (Lst Occasion))
	           (stoppers starters - (Lst Process-instance)
		    new-sit - Situation dom - Domain)
   (let ((adds !()) (dels !()) - (Lst Occasion))
      (letrec ((elapsed-reset - Void (proc-inst - Process-instance
				      newval - Float)
		  (let ((dl (assertion-find-and-erase
			       `(current-value
				    (elapsed ,(!_term (!_uterm proc-inst)))
				    ?e)
			       ua-id* (empty-env) new-sit))
			(al (assertion-add
			       `(current-value
				   (elapsed ,(!_term (!_uterm proc-inst)))
				   ,newval)
			       new-sit dom)))
		     (!= adds (nconc al *-*))
		     (!= dels (nconc dl *-*)))))
	 (repeat :for ((proc-inst :in stoppers) - Process-instance)
	    (elapsed-reset proc-inst -1))
	 (repeat :for ((proc-inst :in starters) - Process-instance)
	    (elapsed-reset proc-inst 0))
	 (repeat :for ((del :in dels))
	    (match-let (current-value (elapsed ?procterm) ?el)
		       (!_term del)
	       (cond ((> el 0.0)
		      (let ((dl (assertion-find-and-erase
				    `(last-elapsed ,procterm ?prev-el)
				    ua-id* (empty-env) new-sit))
			    (al (assertion-add `(last-elapsed ,procterm ,el)
					       new-sit dom)))
			 (!= adds (nconc al *-*))
			 (!= dels (nconc dl *-*)))))))
;;;;	 (cond ((sit-patho new-sit)
;;;;		(dbg-save new-sit)
;;;;		(signal-problem processes-elapsed-reset
;;;;		   "Pathology resetting elapsed")))
	 (values adds dels))))

#|
(defproc update-elapsed - (Multvals eladds eldels - (Lst Occasion))
	           (new-actives 
		    old-actives - (Lst Process-instance)
		    new-sit - Situation
		    elapsed-before - (Alt Time-int (Const *never))
		    dom - Domain)
   (repeat :for ((na :in new-actives) - Process-instance
		 elap-val-pat aterm - Sexp 
		 :collectors eladds eldels - Occasion)
      (!= aterm (!_term (!_uterm na)))
      (!= elap-val-pat `(current-value (elapsed ,aterm ?e)))
      (cond ((proc-inst-in-list na old-actives)
	     (let ((al (deduce 
			  elap-val-pat ua-id* (empty-env) new-sit dom)))
	        (cond ((null al)
		       (signal-problem update-elapsed
			  "No value for (elapsed " aterm ")"
			  :% " in " new-sit))
		      ((null (cdr al))
		       (list-collect
			   eldels
			   (assertion-erase elap-val-pat new-sit dom))
		       (list-collect
			  eladds
			  (assertion-clo-add
			      elap-val-pat ua-id*
			      (bdgenv-var-val-update
			         'e ua-id* (car al)
				 (\\ (el) (+ el elapsed-before)))
			      new-sit dom)))
		      (t
		       (signal-problem update-elapsed
			  "Too many values for (elapsed " aterm ")"
			  :% " in " new-sit
			  :% " to wit: " al)))))
	    (t
	     (list-collect
	        eladds
		(assertion-add
		   `(current-value (elapsed ,uterm) ,elapsed-before)
		    new-sit dom))))))
|#

(deffunc bdgenv-var-val-update - Bdgenv
	                     (sym - Symbol id - Varid env - Bdgenv
			      newval-fun - (Fun Obj (Obj)))
   (let ((bdg (uvar-lookup sym id env)))
      (cond (bdg
	     (let ((newval (funcall newval-fun (!_skel (!_val bdg)))))
		(make Bdgenv
		   (cons (make Varbdg sym id 
				      (make Expclo newval false))
			 env))))
	    (t
	     (signal-problem bdgenv-var-val-update
		"No value for " sym "/" id " in " env)))))

(deffunc uterm-exp->fl-sexp - Sexp (ut - Uterm-exp)
   (cond ((is Uterm ut)
	  `(fl-v ,(!_term ut)))
	 ((atom ut)
	  (be Sexp ut))
	 (t
	  (<# uterm-exp->fl-sexp
	      (be (Lst Uterm-exp) ut)))))

(deffunc proc-inst-in-list - Boolean (p - Process-instance
				      pl - (Lst Process-instance))
   (exists (p1 :in pl)
      (eq (!_uterm p1) (!_uterm p))))

;;;; Not currently used.
(deffunc is-samelistq - Boolean (l1 l2 - (Lst Obj))
   (and (subsetp l1 l2)
	(subsetp l2 l1)))


