import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.io.*;
import java.net.*;

public class Demo_home
{
  JFrame chat_frame;   // text_frame;
  JPanel chat_panel;
  Downable_scroll_pane chat_area_scroll;
  JTextArea chat_area;
  JTextField chat_entry;
  static Demo_home demo;
  static Thread local_lisp_thread, remote_demo_thread;
  PrintWriter to_remote = null;
  BufferedReader from_remote;
  static boolean demo_running = true;

  public Demo_home()

  {
    chat_frame = new JFrame("Chat Server");
    chat_frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    chat_panel = (JPanel) chat_frame.getContentPane();
    chat_panel.setLayout(new BorderLayout());
    chat_area = new JTextArea(new PlainDocument(), null, 20, 60);
    chat_area.setFont(new Font("Serif", Font.PLAIN, 18));
    chat_area.setLineWrap(true);
    chat_area.setWrapStyleWord(true); 
    chat_area.setEditable(false);
    chat_area.setBorder(new EmptyBorder(3,3,3,3));
    chat_area_scroll = new Downable_scroll_pane(chat_area);
    chat_entry = new JTextField();
    chat_entry.addActionListener
                    (new Chat_entry_listener(chat_entry,
					     chat_area,
					     new Callback_from_chat()));
    chat_panel.add(chat_area_scroll, BorderLayout.CENTER);
    chat_panel.add(chat_entry, BorderLayout.SOUTH);
    chat_frame.pack();
  }

  public static void main(String[] argv)
  {
    try
    {
      InetAddress local_addr = InetAddress.getLocalHost();
      String host_name = local_addr.getHostName();
      String host_addr = local_addr.getHostAddress();
      byte[] raw_addr = local_addr.getAddress();
      System.out.println("Server host name = " + host_name);
      System.out.println("Server IP address = " + host_addr);
      int int_addr = 0;
      for (int i=0;i<=3;i++)
	{
	  System.out.println("raw[" + i + "] = " + raw_addr[i]);
	  int_addr = (int_addr << 8) | raw_addr[i];
	}

      System.out.println("Server integer address = " + int_addr);
    }
    catch (Exception e)
    {
      System.out.println("Can't get server host data\n because of "
			 + e);
    }

    demo = new Demo_home();
    demo.chat_frame.setVisible(true);
    remote_demo_thread = new Thread(demo.new Remote_demo_connect());
    remote_demo_thread.start();
    local_lisp_thread = new Thread(demo.new Local_lisp_connect());
    local_lisp_thread.start();
  }

  class Remote_demo_connect implements Runnable
  {
    ServerSocket ch_serv_sock;
    Socket ch_clisock;

    public void run()
    {

      try
	{
	  ch_serv_sock = new ServerSocket(7777);
	  while (demo_running)
	    {
	      ch_clisock = ch_serv_sock.accept();
	      chat_area.append("\n**Client detected**\n");
	      from_remote
		= new BufferedReader(new InputStreamReader
				             (ch_clisock.getInputStream()));
	      to_remote
		= new PrintWriter(new OutputStreamWriter
				         (ch_clisock.getOutputStream()));
	      if (local_lisp_thread != null)
		local_lisp_thread.interrupt();
	      to_remote.println("CType lines terminated by carriage returns");
	      to_remote.flush();
	      while (demo_running)
		{
		  String in_from_remote = from_remote.readLine();
		  chat_area.append("\n" + in_from_remote);
		  chat_area_scroll.scroll_to_end();
		}
	    }
	}
      catch(IOException e)
	{
	  System.out.println("In remote-observer link, IOException " + e);
	  System.exit(1);
	}
      System.exit(0);
    }
  }

  public class Local_lisp_connect implements Runnable
  {
    ServerSocket ll_serv_sock;
    Socket ll_clisock;
    BufferedReader from_lisp;

    public void run()
    {
      try
	{
	  ll_serv_sock = new ServerSocket(7778);
	  while (demo_running)
	    {
	      ll_clisock = ll_serv_sock.accept();
	      from_lisp
		= new BufferedReader(new InputStreamReader
					     (ll_clisock.getInputStream()));
	      chat_area.append("\nLocal Lisp checks in");
	      chat_area_scroll.scroll_to_end();
	      while (demo_running && to_remote == null)
		{
		  System.out.println("Waiting for remote observer");
		  try
		    {
		      local_lisp_thread.sleep(20000);
		    }
		  catch(InterruptedException e)
		    {}
		}
	      try
		 {
		   boolean abort = false;
		   while (demo_running && to_remote != null)
		     {
		       System.out.println("Reading from Lisp");
		       String lisp_io = from_lisp.readLine();
		       if (lisp_io == null)
			 {
			   System.out.println("Null from Lisp");
			   demo_running = false;
			 }
		       else if (lisp_io.equals("!abort"))
			 abort = true;
		       else
			 {
			   to_remote.println("L" + lisp_io);
			   to_remote.flush();
			   System.out.println("Read " + lisp_io);
			 }
		     }
		 }
	       catch(IOException e)
		 {
		   System.out.println("Connection to local lisp broken ("
				      + e + ")");
		 }
	    }
	}
      catch(IOException e)
	{
	  System.out.println("In lisp link, " + e);
	  System.exit(1);
	}
      System.exit(0);
    }
  }

  class Callback_from_chat implements Callback_string
  {
    public void accept(String from_chat)
    {
      //      System.out.println("User typed " + from_chat);
      if (to_remote != null)
	{
	  chat_area.append("\nDemo> " + from_chat);
	  chat_area_scroll.scroll_to_end();
	  to_remote.println("CDemo> " + from_chat);
	  to_remote.flush();
	}
    }
  }

  class Stop_threads extends WindowAdapter
  {
    public void windowClosed(WindowEvent e)
    {
      demo_running = false;
//      if (local_lisp_thread != null)
//	local_lisp_thread.stop();
//      if (remote_demo_thread != null)
//	remote_demo_thread.stop();
      System.out.println("Threads shutting down");
    }
  }
}
