import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.text.*;
import javax.swing.border.*;
import java.io.*;
import java.net.*;

// Connects to Demo_home from someplace far, far away.

public class Remote_demo 
{
  static final int demo_port = 7777;
  JFrame chat_frame, lisp_frame, text_frame, graphics_frame;
  JPanel chat_panel, lisp_panel;
  Downable_scroll_pane chat_area_scroll, lisp_area_scroll;
  JTextArea chat_area, lisp_area;
  JTextField chat_entry;
  static Remote_demo client;
  Socket server_link;
  PrintWriter to_server;
  BufferedReader from_server;

  public Remote_demo()
  {
    // Set up all frames (not all visible initially)

    chat_frame = new JFrame("Demo Observer");
    chat_frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
    chat_panel = (JPanel) chat_frame.getContentPane();
    chat_panel.setLocation(10, 0);
    chat_panel.setLayout(new BorderLayout());
    chat_area = new JTextArea(new PlainDocument(), null, 20, 60);
    chat_area.setFont(new Font("Serif", Font.PLAIN, 18));
    chat_area.setLineWrap(true);
    chat_area.setWrapStyleWord(true); 
    chat_area.setEditable(false);
    chat_area.setBorder(new BevelBorder(BevelBorder.LOWERED));
    chat_area.setFocusable(false);
    chat_area_scroll = new Downable_scroll_pane(chat_area);
    chat_entry = new JTextField();
    chat_entry.addActionListener
                  (new Chat_entry_listener(chat_entry,
					   chat_area,
					   new Callback_from_chat()));
    chat_panel.add(chat_area_scroll, BorderLayout.CENTER);
    chat_panel.add(chat_entry, BorderLayout.SOUTH);
    chat_frame.pack();

    lisp_frame = new JFrame("Lisp-listener Observer");
    lisp_frame.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
    lisp_panel = (JPanel) lisp_frame.getContentPane();
    lisp_panel.setLayout(new BorderLayout());
    lisp_area = new JTextArea(new PlainDocument(), null, 25, 80);
    lisp_frame.setLocation(new Point(10,
				     chat_frame.getLocation().y
				        + chat_frame.getHeight()
                                        + 7));
    lisp_area.setFont(new Font("Monospaced",Font.PLAIN,20));
    lisp_area.setBorder(new EmptyBorder(3,3,3,3));
    lisp_area.setFocusable(false);
    lisp_area_scroll = new Downable_scroll_pane(lisp_area);
    lisp_panel.add(lisp_area_scroll, BorderLayout.CENTER);
    lisp_frame.pack();
  }

    
  public static void main(String[] argv)
  {
    client = new Remote_demo();
    client.chat_frame.setVisible(true);
    String demo_host;
    //JViewport vp = client.lisp_area_scroll.getViewport();
    try
      {
	System.out.println("Type IP address or hostname: ");
	demo_host =
	   new BufferedReader(new InputStreamReader(System.in))
	               .readLine();
	client.server_link = new Socket(demo_host, demo_port);
	client.from_server
	  = new BufferedReader(new InputStreamReader
			             (client.server_link.getInputStream()));
	client.to_server
	  = new PrintWriter(new OutputStreamWriter
			          (client.server_link.getOutputStream()));
	while (true)
	  {
	    String in_from_server = client.from_server.readLine();
	    char ch = in_from_server.charAt(0);
	    in_from_server = in_from_server.substring(1);
	    switch (ch)
	      {
	      case 'C':
		client.chat_area.append("\n" + in_from_server);
		client.chat_area_scroll.scroll_to_end();
		break;
	      case 'L':
		client.lisp_frame.setVisible(true);
		client.lisp_area.append("\n" + in_from_server);
		client.lisp_area_scroll.scroll_to_end();
		//		System.out.println("Lisp view pos = " + vp.getViewPosition());
		break;
	      default:
		client.chat_area.append("?'"
					+ ch + "'" + in_from_server
					+ "\n\n");
	      }
	  }
      }
    catch(IOException e)
      {
	System.out.println("IOException " + e);
	System.exit(1);
      }
  }

  class Callback_from_chat implements Callback_string
  {
    public void accept(String from_chat)
    {
      chat_area.append("\nObserver> " + from_chat);
      to_server.println("Observer> " + from_chat);
      to_server.flush();
    }
  }
}
