;-*- Mode: Common-lisp; Package: ytools; Readtable: ytools; -*-
(in-package :ytools)

(defconstant +demo-port+ 7778)

(defvar server-address* nil)

(defvar last-socket*)

(defvar demo-dbg* false)

(defun connect-to-demo (&optional (server-host false))
      (cond (server-host
	     (cond ((is-String server-host)
		    (!= server-address* server-host))
		   (t
		    (signal-problem connect-to-demo
		       "Illegal server-host " server-host))))
	    (server-address*
	     (!= server-host server-address*))
	    (t 
	     (out (:to *query-io*) "Name or IP address of server machine: ")
	     (setq server-host
                   (string-trim " \t" (in (:from *query-io*) :linestring)))
	     (cond ((string= server-host "")
		    (setq server-host server-address*))
		   (t
		    (setq server-address* server-host)))))
      (let ((socket (acl-socket:make-socket
			     :connect ':active
			     :remote-host server-host
			     :remote-port +demo-port+)))
	 (!= last-socket* socket)
	 (unwind-protect
            (let-fun ()
               (out (:to *query-io*) "Found server" :%)
	       (!= tpl:*read*
		   (\\ (&optional (isrm *terminal-io*) (eof-error-p t)
				  (eof-val nil) (recursive-p nil))
		      (let ((r (read isrm eof-error-p eof-val recursive-p)))
			 (try-send-to-socket-stream "> " r)
			 r)))
	       (!= tpl:*print*
		   (\\ (x &optional (srm *standard-output*))
		      (try-send-to-socket-stream " " x)
		      (cond ((eq srm 't)
			     (!= srm *standard-output*)))
		      (print x srm)))
	    :where
	       (try-send-to-socket-stream (prefix x)
		  (handler-case
		     (progn (dbg-out demo-dbg*
			       "Sending to socket: " (:a prefix) x :%)
			    (out (:to socket) (:a prefix) x :%)
			    (force-output socket))
		   (error ()
		      (out (:to *terminal-io*)
			   "Can't write to socket stream; bailing" :%)
		      (setq tpl:*read* nil)
		      (setq tpl:*print* nil)))))
	   (cond ((and socket (not tpl:*read*) (not tpl:*print*))
		  (format t "Abort!~%")
		  (cond (socket
			 (close socket))))))))

(defmacro vv (x) '(values))