;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: discrtproj.lisp,v 1.11 2005/11/30 15:53:21 dvm Exp $

(depends-on %module nisp)

(depends-on :at-run-time %optop/ projutil continproj types)

(deffunc term-type - Opt-type (ut - Uterm env - Typenv)
   (recover-type (!_term ut) univ-type* env))

(deffunc seq-project - (Mlv (~ Situation) Float Integer)
	             (sit - (~ Situation)
		      acts - (Lst (Alt Action Sexp))
		      sit-space - Situation-space dom - Domain)
   (repeat :for ((a :in acts) - (Alt Action Sexp)
		 (tot-time 0.0) - Float (tot-steps 0) st - Integer
		 el - (Alt Time-int (Const *never))
		 (next-sit))
    :result (values next-sit tot-time tot-steps)
      (cond ((not (is Action a))
	     (cond ((atom a)
		    (cond ((not (eq a 'wait))
			   (signal-problem seq-project
			      "Unintelligible action: " a))))
		   (t
		    (!= a (uniquify-action (be Sexp a) dom))))))
      ;;;;(out "Projecting " a :%)
      (!= < next-sit _ _ st el _ _ >
	  (contin-discrete-project sit
				   (be (Alt Action (Const wait)) a)
				   sit-space dom))
      ;;;;(out "el = " el :%)
    :while next-sit
      (!= sit next-sit)
      (!= tot-time (+ *-* (be Float el)))
      (!= tot-steps (+ *-* st))
    :result (values false tot-time tot-steps)))

(declaim (special discrim-bdgs*))

(deffunc contin-discrete-project - (Multvals
				        succ - (~ Situation)
					adds deletes - (Lst Occasion)
					delta-step - (Const 0 1)
					elapsed - (Alt Time-int (Const *never))
					linkid - (~ Symbol)
					assumptions - (Lst Sexp))
                         (sit - Situation act - (Alt Action (Const wait))
			  sit-space - Situation-space dom - Domain)
   (cond ((or (eq act 'wait)
	      (one-value (is-wait (be Action act))))
	  (multi-let (((succ adds deletes elapsed)
		       (wait-project false sit sit-space dom)))
	     (values succ adds deletes 0 elapsed false !())))
	 (t
	  (multi-let (((succ adds deletes linkid assumptions)
		       (project false sit (be Action act) sit-space dom)))
	     (values succ adds deletes (cond (succ 1) (t 0))
		     0.0 linkid assumptions)))))

;; Returns successor situation, addlist, deletelist, and assumptions
;; required to make the projection work.  This last value is () here,
;; unless the optimistic-projector* makes some assumptions.

(deffunc project - (Multvals succ - (~ Situation)
			     adds deletes - (Lst Occasion)
			     linkid - (~ Symbol)
			     assumptions - (Lst Sexp))
	   (allow-anomalies - Boolean
	    sit - Situation act - Action sit-space - Situation-space dom - Domain)
   ;;;(setf act (uniquify-action act dom))
   (let ((p (find-old-projection sit act sit-space))
	 - (~ Sitsuccspec))
      (cond (p
             (values (cond ((!_forced p) false)
			   (t (!_sit p)))
		     (!_adds p)
                     (!_deletes p)
                     (!_outlink p)
		     (!_assumptions p)))
            (t
	     (fresh-act-project allow-anomalies sit act sit-space dom true)))))

(specdecl (optimistic-projector* false)
	  - (~ (Fun (Multvals sit - Situation
			      adds deletes - (Lst Occasion)
			      linkid - (~ Symbol)
			      assumptions - (Lst Sexp))
		    (Boolean Action Internalized-action-defn Varid Bdgenv
		     Situation Situation-space Domain Boolean))))

(declaim (special optimistic-projector*))

;; The last arg allows us to avoid actually changing anything when
;; debugging.
(deffunc fresh-act-project - (Multvals succ - (~ Situation)
				       adds deletes - (Lst Occasion)
				       linkid - (~ Symbol)
				       assumptions - (Lst Sexp))
                       (allow-anomalies - Boolean
			sit - Situation uact - Action
			sit-space - Situation-space
			dom - Domain alter - Boolean)
   (cond ((eq (!_term uact) 'watch)
	  (values sit !() !() false !()))
	 (t
	  (multi-let (((adefn env)
		       (act-defn-term-unify uact dom)))
	     (cond ((!_precond adefn)
		    (let ((pre 
			     (bind ((optimist-fn*
				       false))
				(deduce
				   (!_precond adefn) eff-varid* env sit dom))))
		       (cond ((null pre)
			      (infeas-act-record sit uact sit-space alter))
			     (t
			      (act-project-given-precond
				 allow-anomalies uact adefn
				 eff-varid* (car pre)
				 sit sit-space dom alter)))))
		   (t
		    (act-project-given-precond
		       allow-anomalies uact adefn eff-varid* env
		       sit sit-space dom alter)))))))

(deffunc act-defn-term-unify - (Multvals adefn - Internalized-action-defn
					 env - Bdgenv)
	           (uact - Action dom - Domain)
   (let-fun ()
      (match-cond (!_term uact)
	 ?( (?(:& ?ss ?(:\| dur-start dur-stop))
	     (?dfun ?@dargs))
	   (let ((af (find-domain-bdg-val (be CSymbol dfun) dom)))
	      (cond ((is Causation-function af)
		     (let ((ddefn (!_defn af)))
			(cond ((is Durative-action-defn ddefn)
			       (let ((iddefn
					(be Internalized-durative-defn
					    (causation-defn-projectable
					       ddefn dom))))
				  (do-unify
				     (cond ((eq ss 'dur-stop)
					    (!_stop-view iddefn))
					   (t (!_start-view iddefn))))))
			      (t
			       (signal-problem act-defn-term-unify
				  "In " uact ", " `(,dfun ,@dargs)
				  :% " is not a durative-action term")))))
		    (t
		     (signal-problem act-defn-term-unify
			"In " uact ", " dfun
			" is not a Causation-function")))))
	 ?( (?(:\| dur-start dur-stop)
	     ?_)
	   (signal-problem act-defn-term-unify
	      "Mal-formed " ss " term: " uact))
	 ?( (?afun ?@_)
	   (let ((af (find-domain-bdg-val (be CSymbol afun) dom)))
;;;;	      (out "af = " af " Causation-function? "
;;;;		   (is Causation-function af) :%)
	      (cond ((and af
			  (is Causation-function af))
		     (let ((adefn (!_(Causation-function defn) af)))
			(cond ((is Action-defn adefn)
			       (let ((adefn (be Internalized-action-defn
					        (causation-defn-projectable
						   adefn dom))))
				  (do-unify adefn)))
			      (t
			       (signal-problem act-defn-term-unify
				  "In " uact ", " afun
				  :% " is not an action function")))))
		    (t
		     (signal-problem act-defn-term-unify
			"In " uact ", " afun
			" is not a Causation-function")))))
	(t
	 (signal-problem act-defn-term-unify
	    "Ill-formed action: " uact)))
    :where
       (:def do-unify - (Multvals defn - Internalized-action-defn
				  env - Bdgenv)
                (defn - Internalized-action-defn)
	  (multi-let (((ok e)
		       (unify (!_term defn)
			      (!_term uact)
			      eff-varid* ground-id* nil)))
	     (cond (ok
		    (values defn e))
		   (t
		    (signal-problem act-defn-term-unify
		       "Action definition fails to ~
				       unify: " (!_term uact))))))))

(defproc infeas-act-record - (Multvals succ - (~ Situation)
				       adds deletes - (Lst Occasion)
				       linkid - (~ Symbol)
				       assumptions - (Lst Sexp))
                    (sit - Situation act - Action sit-space - Situation-space
		     alter - Boolean)
   (cond (alter
	  (succ-record true sit 0.0 1 act false !() !() 0.0 !() sit-space)))
   (values false !() !() false !()))

(defproc act-project-given-precond - (Multvals succ - Situation
				       adds deletes - (Lst Occasion)
				       linkid - (~ Symbol)
				       assumptions - (Lst Sexp))
                       (allow-anomalies - Boolean
			uact - Action adefn - Internalized-action-defn 
		        aid - Varid bdgs - Bdgenv sit - Situation
			sit-space - Situation-space
			dom - Domain alter - Boolean)
   (cond (optimistic-projector*
	  (funcall optimistic-projector*
		   allow-anomalies uact adefn aid bdgs sit sit-space dom alter))
	 (t
	  (multi-let (((succ adds dels assumptions)
		       (effect-project allow-anomalies uact adefn aid bdgs
				       sit sit-space dom alter)))
	     (values succ adds dels false assumptions))))
   )

(defproc effect-project - (Multvals succ - Situation
				    adds deletes - (Lst Occasion)
				    ;;;;linkid - (~ Symbol)
				    assumptions - (Lst Sexp))
                       (allow-anomalies - Boolean
			uact - Action adefn - Internalized-action-defn
		        aid - Varid bdgs - Bdgenv sit - Situation
			sit-space - Situation-space dom - Domain alter - Boolean)
  (multi-let (((succ adds dels)
	       (do-effect allow-anomalies uact
			  (!_effect adefn)
			  aid bdgs sit sit-space dom)))
     (cond (alter
	    (!= succ 
		(succ-record false sit 0.0 1 uact succ adds dels 0.0 !() sit-space))))
     (values succ adds dels !())))

(defproc do-effect - (Multvals succ - Situation
			       adds deletes - (Lst Occasion))
		 (allow-anomalies - Boolean
		  uact - Action eff - Sexp id - Varid bdgs - Bdgenv
		  sit - Situation sit-space - Situation-space dom - Domain)
   (bind ((optimist-fn* false))
      (multi-let (((adds deletes)
                   (deduce-effects eff id bdgs sit dom)))
	 (let ((next-sit
		  (cond ((or (not (null adds)) (not (null deletes)))
			 (build-new-sit
			    allow-anomalies uact adds deletes id bdgs
			    sit sit-space dom))
			(t sit))))
	   (values next-sit adds deletes)))))

;;; Note that this builds a new sit, but it isn't uniquified or linked
;;; to its predecessor yet.
;;; This is called after an infinitesimal time has passed, so it doesn't
;;; change any continuous quantities.  NOT APPROPRIATE FOR MODELING
;;; PASSAGE OF TIME; use 'wait-project' for that.
(defproc build-new-sit - (Multvals new-sit - Situation
				   adds deletes - (Lst Occasion))
	    (allow-anomalies - Boolean
	     uact - Action adds deletes - (Lst Occasion)
	     id - Varid bdgs - Bdgenv sit - Situation
	     sit-space - Situation-space dom - Domain)
;;;;   (cond ((sit-patho sit)
;;;;	  (dbg-save sit adds deletes)
;;;;	  (signal-problem build-new-sit
;;;;	     "Pathology before 'new-succ-sit'")))
   (let ((new-sit (new-succ-sit sit uact)))
      (assertion-find-and-erase
	 '(process-transition ?w ?p) dummy-id* !()
	 new-sit)
      (delete-and-add adds deletes id bdgs new-sit dom)
      (multi-let (((al dl _ new-sit-with-processes)
		   (setup-process-complex
		      allow-anomalies new-sit !() sit 0.0 sit-space dom)))
	 (!= adds (nconc al *-*))
	 (!= deletes (nconc dl *-*))
	 (!= (!_frozen new-sit-with-processes) true)
	 (values new-sit-with-processes adds deletes))))

;;;;;;; Called by forward-chaining rules created in planprob.nsp .
;;;;(defproc check-process - Void
;;;;		   (id - Varid bdgs - Bdgenv sit - Situation dom - Domain
;;;;		    discrete-conds continuous-conds - (Lst Sexp)
;;;;		    pdefn - Internalized-process-defn)
;;;;   (!= new-potential-processes*
;;;;       (process-instantiate-potentials
;;;;	  discrete-conds continuous-conds id bdgs sit pdefn dom)))

(defproc symbol-declare-locally - Void (sym - Symbol ty - Opt-type val - Obj
					sit - Situation dom - Domain)
   (incremental-domain-bdg sym ty val dom)
   (let ((td (nisptype::Type-desig ty)))
      (cond ((is-Symbol td)
	     (let ((initsit (find-init-situation sit)))
	        (with-thawed-situation initsit
		   (changing-fact-index initsit
		      (assertion-add `(is ,td ,sym) sit dom))))))))

;; Version of create-local-bdg that updates the generation counter.
;; This is used at "run time" to add a single binding.  
;; create-local-bdg is used repeatedly at "parse time" to add new bindings,
;; where someone else takes responsibility for the domain's generation
;; to be set properly.
(defproc incremental-domain-bdg - Domain-bdg
	                   (sym - Symbol ty - Opt-type val - Obj
			    dom - Domain)
   (let ((bdg (place-domain-bdg sym dom)))
      (!= (!_val bdg) val)
      (!= (!_type bdg) ty)
      (!= (!_generation dom)
	  (next-generation))
      bdg))

;;; For debugging
(deffunc seq-movie - Situation (sit - Situation
				acts - (Lst (Alt Action Sexp))
				sit-space - Situation-space dom - Domain)
   (repeat :for ((a :in acts) - (Alt Action Sexp)
		 (i = 0 :by 1) - Integer
		 next-sit - (~ Situation)
		 adds deletes - (Lst Occasion)
		 delta - Integer
		 elapsed - (Alt Time-int (Const *never))
		 linkid - (~ Symbol)
		 assumptions - (Lst Sexp))
    :result sit
      (out i 1 sit)
      (let ((pc (!_processes sit)))
	 (out (:q ((not pc)
		   2 "-- No processes")
		  (t
		   :% 2 "Processes: "
		   :% 5 pc))
	      :%))
      (cond ((not (is Action a))
	     (!= a (uniquify-action (be Sexp a) dom))
	     (cond ((atom a)
		    (cond ((not (eq a 'wait))
			   (signal-problem seq-movie
			      "Unintelligible action: " a)))))))
      (out "Action: " a :%)
      (!= < next-sit adds deletes delta elapsed linkid assumptions >
	  (contin-discrete-project sit
				   (be (Alt Action (Const wait)) a)
				   sit-space dom))
    :while next-sit
      (out (:q ((eq elapsed '*never)
		:% 3 "INFINITE time elapses!" :%)
	       (t
		(:e (decl (elapsed - Float)
		       (:o
			(:q ((or (and (> delta 0) (> elapsed 0.0))
				 (and (=< delta 0) (=< elapsed 0.0)))
			     :% "Unexpected delta, elapsed: " delta
			        ", " elapsed :%)
			    ((> delta 0)
			     :% 3 "Steps: " delta :%)
			    (t
			     :% 3 "Elapsed time: "
			        (:f "~,2f" elapsed) :%)))))))
	   3 "Adds: " adds
	   :% 3 "Deletes: " deletes
	   (:q (linkid
		:% 3 "Linkid = " linkid
		(:q ((not (null assumptions))
		     :% 3 "Assumptions: " assumptions)))
	       ((not (null assumptions))
		:% 3 "Assumptions: " assumptions))
	   :%)
      (!= sit next-sit)
    :result sit))
