;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)

(depends-on nisp)

(depends-on :at-run-time %hacks/ gctools)

;;;;(!= note-transition-sits* true)
;;;;
;;;;(out (:to *query-io*)
;;;;     "Setting note-transition-sits* to TRUE" :%)

(deffunc sit-disting (sit1 sit2 - Situation)
   (let ((elts1 (sit-contents sit1))
	 (elts2 (sit-contents sit2)))
      (let ((one-not-two (complementq elts1 elts2))
	    (two-not-one (complementq elts2 elts1))
	    (one-and-two (intersection elts1 elts2)))
	 (tuple (tuple ':one-not-two (len one-not-two) one-not-two)
		(tuple ':two-not-one (len two-not-one) two-not-one)
		(tuple ':both (len one-and-two) one-and-two)))))

(deffunc sit-index-measure - (Multvals numtrees numconses - Integer) (sit - Situation)
   (exp-index-measure (!_diff-from-init sit)))
      
(deffunc exp-index-measure - (Multvals numtrees numconses - Integer) (exin - Exp_index)
   (exptree-measure (!_tree exin)))

(deffunc sit-measure - (Multvals numtrees numconses - Integer)
	             (init-sit - Initial-situation)
   (let ((explored !()) - (Lst Situation)
	 (numexplored 0) - Integer)
      (labels ((explore - (Multvals numtrees numconses - Integer)
		        (sit - Situation)
		  (cond ((memq sit explored)
			 (values 0 0))
			(t
			 (!= explored (cons sit *-*))
			 (!= numexplored (+ *-* 1))
			 ;;;;(out numexplored 1)
			 (let ((numtrees 0) (numconses 0))
			    (multi-let (((ntr nco)
					 (exptree-measure
					    (!_tree (!_diff-from-init sit)))))
			       (!= numtrees (+ *-* ntr))
			       (!= numconses (+ *-* nco)))
			    (repeat :for ((succ :in (!_succs sit)))
			       (cond ((!_sit succ)
				      (multi-let (((ntr nco)
						   (explore (!_sit succ))))
					 (!= numtrees (+ *-* ntr))
					 (!= numconses (+ *-* nco)))))
			     :result (values numtrees numconses)))))))
	 (multi-let ((numtrees 0) (numconses 0))
	    (cond ((!_fact-index init-sit)
		   (multi-let (((ntr nco)
				(exptree-measure
				   (!_tree (be Exp_index (!_fact-index init-sit))))))
		      (!= numtrees (+ *-* ntr))
		      (!= numconses (+ *-* nco)))))
	    (multi-let (((ntr nco)
			 (explore init-sit)))
	       (!= numtrees (+ *-* ntr))
	       (!= numconses (+ *-* nco)))
	    (values numtrees numconses)))))			      

(deffunc exptree-measure - (Multvals numtrees numconses - Integer)
	                 (et - exptree)
   (labels ((walk (sub-et - exptree)
	          - (Multvals numtrees numconses - Integer)
	       (cond ((exists (tab :in (opt::exptree-tables sub-et))
			 (opt::exptree_table-operative tab sub-et))
		      (repeat :for ((tab :in (opt::exptree-tables sub-et))
				    - Obj
				    (numtrees 0)
				    (numconses
				       (rehash-prospects-len sub-et))
				    - Integer)
			 (repeat :for ((e :in (opt::exptree_table-entries
					          tab)))
			    (multi-let (((ntr nco)
					 (walk (opt::exptree_entry-tree e))))
			       (!= numtrees (+ *-* ntr 1))
			       (!= numconses (+ *-* (+ nco 1)))))
		       :result (values numtrees numconses)))
		     (t
		      (values 0
			      (+ (rehash-prospects-len sub-et)
				 (let ((cl (opt::exptree-contents sub-et false)))
				    (cond ((eq cl 'opt::*uncomputed) 0)
					  (t (len cl)))))))))

	    (rehash-prospects-len - Fixnum (sub-et - exptree)
	       (let ((rehp (opt::exptree-rehash-prospects sub-et)))
						   (cond ((eq rehp 'opt::*unknown) 0)
							 (t (len rehp))))))
      (walk et)))

(deffunc shrink-sit - Void (sit - Initial-situation)
   (!= (opt::Initial-situation-sit-index sit) false)
   (!= (!_more sit) false)
   (!= (!_contents sit) 'opt::*uncomputed)
   'shrunk)

(specdecl (array-base-size* 1) (array-elt-size* 4) - Fixnum)
;;; Note: An (array t) of n elements occupies about 
;;; (+ array-base-size* (* array-elt-size* n)) bytes

(deffunc array-obj-ref-array-bytes - Integer (aa - (Ary Obj 1))
   (repeat :for ((i = 1 :to (aref aa 0))
		 (totbytes 0))
      (!= totbytes
	  (+ *-* array-base-size*
	     (* (array-dimension (aref aa i) 0)
		array-elt-size*)))
    :result totbytes))

