;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: next-exec-state.lisp,v 1.3 2005/10/31 13:54:41 dvm Exp $

;;; Using 'copy-with-changes' on large data structures is costly.  
;;; This version is specific to copying Exec-states, and gathers
;;; statistics on which slots change most frequently.

(depends-on %module/ nisp)

(depends-on %optop/ copy-w-changes)

(specdecl (gather-next-state-stats* true) - Boolean
          (next-state-stats* !()) - (Lst (Lrcd Symbol Integer)))

(defmacro next-exec-state (&whole e cur-state^ changes)
   (cond (gather-next-state-stats*
          (repeat :for ((chl = changes :then (cddr chl)))
           :until (null chl)
           :result nil
           :until (null (cdr chl))
           :result (signal-problem next-exec-state
                      "Odd number of elements in field-change list: "
                      e
                      (:continue "I'll ignore the leftover bit"))
             (let ((k (car chl)))
                (cond ((is-Keyword k)
                       (!= (alref next-state-stats* k 0)
                           (+ *-* 1)))
                      (t
                       (signal-problem next-exec-state
                          "Illegal field in 'next-exec-state': "
                          k)))))))
   `(copy-with-changes ,cur-state^ - Exec-state
       ,changes))
