;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: optexec-nocmplr.lisp,v 1.1 2005/02/24 04:55:56 dvm Exp $

(depends-on %module/ nisp)

(depends-on :at-run-time %optop/ execute domain procmod maxmatch)

;;; Important: The 'sit' argument is _not_ the situation in which the
;;; plan will be executed; it's there to be used only if the expansion
;;; of 'plan' depends on the value of something in the current situation.
(deffunc plan->thread - Thread (plan - Sexp 
				continuation - Thread-cont
				stack - (Lst Obj) 
				sit - Situation env - Typenv dom - Domain)
   (let ((h (plan-expander plan))
	 - (~ (Fun Thread (Sexp Thread-cont (Lst Obj)
			   Situation Typenv))))
      (cond (h
	     (new-Thread
		(\\ (es - Exec-state)
		   (cond ((not (eq (!_mode es) ':real))
			  (multi-let (((stat new-es _)
				       (cached-thread-result
					  es plan
					  (new-Thread
					     continuation `(execute ,plan) stack)
					  dom)))
			     (cond (stat
				    (values stat new-es))
				   (t
				    (funcall h plan continuation
					     stack sit env)))))
			 (t
			  (funcall h plan continuation stack sit env))))
		`(do ,plan) stack))
	    (t
	     (act->thread plan continuation stack sit env dom)))))

(datafun-table plan-expanders* plan-thread :size 100)

(specdecl plan-expanders* - (Htb (Fun Thread (Sexp Thread-cont (Lst Obj)
						   Situation Typenv))))

(deffunc plan-expander - (~ (Fun Thread (Sexp Thread-cont (Lst Obj)
					 Situation Typenv)))
	              (exp - Sexp)
   (let ((hd (and (consp exp) (car exp))))
      (cond ((is-symbolish hd)
	     (href plan-expanders* hd))
	    (t false))))

(datafun plan-thread wait-while
   (deffunc :^ - Thread (plan - Sexp cont - Thread-cont stack - (Lst Obj)
		         _ - Situation env - Typenv)
      (match-let (wait-while ?procterm)
		  plan
	 (wait-thread plan procterm false cont stack env))))

(datafun plan-thread wait-non-negative
   (deffunc :^ - Thread (plan - Sexp cont - Thread-cont stack - (Lst Obj)
			 _ - Situation env - Typenv)
      (match-let (wait-non-negative ?procterm ?negterm)
		  plan
	 (wait-thread plan procterm negterm cont stack env))))

(deffunc wait-thread - Thread
	             (plan procterm - Sexp negterm - (~ Sexp) cont - Thread-cont
		      stack - (Lst Obj) env - Typenv)
   (let ((dom (find-domain-in-vartypes env)))
      (new-Thread
	 (\\ (es - Exec-state)
	    (cond ((eq (!_mode es) ':real)
		   (signal-problem wait-while-plan-thread
		      "Get real"))
		  (t
		   (let ((sit (!_sit es))
			 (past-sits (<# !_sit (!_hist es))))
		      (let ((succ-sit false) - (~ Situation)
			    (failed false) (forced false) - Boolean
			    (open-subgoal false) - (~ Sexp)
			    (steps 0) - Fixnum
			    adds dels al dl - (Lst Occasion)
			    (elapsed 0.0)  - (Alt Time-int (Const *never))
			    (prev-sit (and (not (null past-sits))
					   (car past-sits)))
			    - (~ Situation)
			    frac - Float)
			 (cond ((process-find procterm sit)
				(!= < succ-sit adds dels elapsed frac >
				    (process-project-and-record
				       sit (!_sit es) prev-sit procterm negterm dom))
				(!= failed
				    (or (not succ-sit)
					(let ((new-pc (!_processes succ-sit)))
					   (and new-pc
						(not (!_kosher new-pc)))))))
			       (t
				(!= failed true)
				(case (!_mode es)
				   (:forced
				    (!= < succ-sit al dl >
					(process-existence-force
					      plan procterm negterm sit past-sits
					      (!_sit-space es)
					      dom))
				    (cond ((not (process-find procterm succ-sit))
					   (dbg-save :run-loud
					      procterm sit succ-sit dom)
					   (signal-problem wait-thread
					      "Process cannot be forced to"
					      " exist: " procterm)))
				    (!= < succ-sit adds dels elapsed frac >
					(process-project-and-record
					   succ-sit (!_sit es) prev-sit
					   procterm negterm dom))
				    (!= < adds dels >
					(add-del-combine al dl adds dels))
				    (!= steps 0)
				    (!= forced true))
				   (:zero-step
				    (!= open-subgoal 
					`(process-exists ,procterm ,negterm))))))
   ;;;;		      (let ((goal-achieved
   ;;;;			       (and succ-sit
   ;;;;				    (or (not goal)
   ;;;;					(not (null (deduce goal id (empty-env)
   ;;;;							   succ-sit dom)))))))
			    (cond ((and forced
					(not (eq elapsed '*never))
					(> frac 0.0)
					(< frac 1.0))
				   (!= elapsed (be Time-int
						   (/ (be Time-int elapsed)
						      frac)))))
   ;;;;			 (cond ((and forced forceproj-dbg*)
   ;;;;				(forced-action-debug
   ;;;;				    act goal goal-achieved true 0 elapsed)))
			    (let ((new-es
				     (with es
					(make-inst Exec-state
					   :mode !>mode
					   :forcings (cond (forced
							    (+ !>forcings 1))
							   (t !>forcings))

					   :steps steps
					   :elapsed elapsed
					   :active
					      (cond ((or (and failed (not forced))
							 open-subgoal)
						     !>active)
						    (t
						     (cons (new-Thread
							      cont
							      `(after ,plan)
							      stack)
							   !>active)))
					   :sit (or succ-sit sit)
					   :sit-space !>sit-space
					   :hist (cons es !>hist)
					   :links !>links :env !>env
					   :blocked
					   (cond (open-subgoal
						  (cons (make Blockage
							   (make Gate
							      ':open-subgoals
							      (list (list open-subgoal)))
							   (list
							      (wait-thread
								 plan procterm negterm
								 cont stack env)))
							!>blocked))
						 (t !>blocked))))))
			       (values
				  (cond ((or forced open-subgoal)
					 (cond ((null (!_active new-es))
						(cond (open-subgoal ':ready)
						      (t ':blocked)))
					       (t ':continuing)))
					(failed   ;; (and ... (eq mode 'projected)) why?
					 ':failed)
					(t ':continuing))
				  new-es)))))))
	 plan stack)))

(specdecl (eff-id* (new-Varid)) - Varid)

(defproc process-existence-force - (Multvals new-sit - Situation
					     adds dels - (Lst Occasion))
	                         (act procterm - Sexp negterm - (~ Sexp)
				  sit - Situation past-sits - (Lst Situation)
				  sit-space - Situation-space dom - Domain)
				 (ignore negterm)
   (let ((ipdefn
	    (causation-view
	       (name-causation-defn
		   (be CSymbol (car procterm))
		   'dur-happening (cdr procterm) dom)
	       #'durative-process-view
	       dom)))
      (multi-let (((_ env)
		   (unify (!_term ipdefn) procterm eff-id* ground-id* (empty-env))))
	 (multi-let (((new-sit adds dels _)
		      (precond-force-true ipdefn act env eff-id* sit past-sits
					  sit-space dom)))
	    (values new-sit adds dels)))))

(defproc process-project-and-record - (Multvals succ - Situation
						adds dels - (Lst Occasion)
					        elapsed - (Alt Time-int
							       (Const *never))
						frac - Float)
	                            (sit start-sit - Situation prev-sit - (~ Situation)
				     procterm negterm - Sexp
				     dom - Domain)
      (multi-let (((final-sit adds dels elapsed frac)
		   (process-project
			 sit (list start-sit prev-sit)
			 procterm negterm dom)))
	 (!= final-sit
	     (succ-record
		false sit elapsed 0
		(uniquify-action (wait-act procterm negterm)
				 dom)
		final-sit adds dels frac !()))
	 (values final-sit adds dels elapsed frac)))

;;; This procedure does two rather different things, depending on whether
;;; 'negterm' is false or a fluent to be made non-negative.  
;;; In the latter case it is interested
;;; only in when that inequality becomes true.  In the former it
;;; is interested only in when the process denoted by 'procterm' finishes.
;;; So if the process ends unexpectedly, it's a failure if negterm is a
;;; term, a success if it's false.
;;; Returned value 'frac' is fraction of ground covered from starting value
;;; of negterm to 0.  It's zero if negterm=false.
(deffunc process-project - (Multvals final-sit - (~ Situation)
				     adds deletes - (Lst Occasion)
				     elapsed - (Alt Time-int
						    (Const *never))
				     frac - Float)
	       (sit - Situation others - (Lst (~ Situation))
		procterm - Sexp
		negterm - (~ Sexp)
		dom - Domain)
               ;; -- negterm = false means that we want to project
	       ;; until the process stops
;;;;      (dbg-out forceproj-dbg*
;;;;	       "Projecting process " procterm)
      (repeat :for ((next-sit sit) - (~ Situation)
		    ;; -- never false except when error occurs
		    (termcond
		       (and negterm `(>= ,(uniquify-continuous-fluent-subterms
					   negterm dom)
					 0.0)))
		    - (~ Uterm-ineq)
		    process - (~ Process-instance)
		    (elapsed 0.0) - Time-int
		    (numwaits 0) - Fixnum
		    (timegrain (domain-temporal-grain-size dom))
		      - Float
		    delta-exasp - (~ Time-int)
		    delta-elap - (Alt Time-int (Const *never))
		    processes - Process-complex
		    trigs - (Lst Ineq-trigger)
		    (adds !()) (dels !()) al dl - (Lst Occasion)
;;;;		    save-sit - Situation
		    :collectors
		    exasperation - Time-int
		    
		    ;; -- Forecast times until desired trigger
		    ;; point is reached, in reverse chrono order.
		    )
         ;; until we reach goal or run out of patience
	 (!= processes (!_processes next-sit))
	 (!= process (process-find procterm next-sit))
       :while process
       :result (progn
		   (cond (negterm
			  (let ((frac (compute-frac)))
			     (cond ((ground-deduce `(=~ ,frac 1.0)
						   next-sit dom)
;;;;				    (cond ((pathological next-sit)
;;;;					   (dbg-save next-sit sit others)
;;;;					   (signal-problem process-project
;;;;					      "Pathology after ground-deduce")))
;;;;				    (dbg-out forceproj-dbg*
;;;;				       "Process ends, satisfying "
;;;;				       termcond)
				    (values next-sit adds dels elapsed frac))
				   (t
;;;;				    (dbg-out forceproj-dbg*
;;;;				       "Process ends without satisfying "
;;;;				       termcond)
;;;;				    (dbg-save sit next-sit frac negterm)
;;;;				    (breakpoint process-project
;;;;				       "frac = " frac)
				    (values false !() !()
					    (cond ((=< frac 0.0) '*never)
						  (t elapsed))
					    frac)))))
			 (t
;;;;			  (dbg-out forceproj-dbg*
;;;;			     "Process ends successfully")
			  (values next-sit adds dels elapsed 0))))
	 (!= trigs (cond (termcond
			  (be (Lst Ineq-trigger)
			      (<? is Ineq-trigger
				  (continuous-trigs
					   (list termcond)
					   (list '(made-it))
					   (!_model processes)
					   next-sit dom))))
			 (t
			  (repeat :for ((tr :in (!_triggers processes))
					:collectors stop-trigs)
			   :when (is-stopper tr)
			   :collect tr
			   :result (cond ((null stop-trigs)
					  ;; Make one up
					  (list (make Ineq-trigger
						   `(dummy)
						   (\\ (ti - Time-int)
						      (- ti
							 way-in-the-future*))
						   `(- *T* (way-in-the-future
							    = ,way-in-the-future*))
						   (list '(made-it)))))
					 (t stop-trigs))))))
       ;; This can happen only if negterm is non-false and has become
       ;; non-negative, i.e., we made it --
       :until (null trigs)
         (!= < delta-exasp _ _ >
	     (compute-trigger-time trigs timegrain))
       :while (and delta-exasp (> delta-exasp 0.0))
       :result
          (let ((frac (compute-frac)))
;;;;	     (dbg-out forceproj-dbg*
;;;;		"Process "
;;;;		(:q ((null trigs)
;;;;		     "ends happily")
;;;;		    (t "never ends"))
;;;;		:% "  accomplished fraction " frac " of " termcond)
	     (values next-sit adds dels elapsed frac))
       :collect (:into exasperation delta-exasp)
       :until (exasperated)
       :result
           (progn
;;;;	      (dbg-out forceproj-dbg*
;;;;		 "Process ends in exasperation")
	      (values false !() !() '*never 0))
;;;;	 (!= save-sit next-sit)
;;;;	 (cond ((pathological save-sit)
;;;;		(dbg-save next-sit save-sit sit others)
;;;;		(signal-problem process-project
;;;;		   "Pathology before wait-project")))
	 (bind ((watch-sit* (cadr others)))
            (!= < next-sit al dl delta-elap >
		(wait-project true next-sit dom)))
;;;;	 (cond ((pathological next-sit)
;;;;		(dbg-save next-sit save-sit sit others)
;;;;		(signal-problem process-project
;;;;		   "Pathology after wait-project")))
	 (cond ((not next-sit)
		(signal-problem process-project
		   "Unexpected inability to project a 'wait'")))
	 (!= adds (union al (complementq *-* dl)))
	 (!= dels (union dl (complementq *-* al)))
	 (!= numwaits (+ *-* 1))
         (!= elapsed (+ *-* (be Time-int delta-elap)))

       :where

	  (is-stopper - Boolean (trig - Ineq-trigger)
	     (exists (eff :in (!_effects trig))
		(cond ((is Ineq-trigger eff)
		       (is-stopper eff))
		      (t
		       (decl (eff - Sexp)
			  (matchq (process-transition
				      stopping ?,procterm)
				  eff))))))

	  (exasperated - Boolean ()
	     (cond ((< numwaits 10)
		    false)
		   (t
		    (let ((exlts (!_elements exasperation)))
		       (let ((delta0 (car exlts)))
			  (let ((decreases
				   (cons delta0
					 (repeat :for
						 ((delta :in (cdr exlts))
						  (prev-delta delta0)
						    - Time-int)
					  :when (< delta prev-delta)
					  :collect delta
					     (!= prev-delta delta)))))
			     (>= (* 3 (len decreases))
				 numwaits)))))))

	  (compute-frac - Float ()
	     (prog1
			  (cond ((and negterm (> elapsed 0))
				 (let ((initval
					  (nth-value
					     1 (opt-eval negterm sit !() dom)))
				       (finalval
					  (nth-value
					     1 (opt-eval negterm next-sit
							 !() dom)))
				       - Number)
				   (/ (- finalval initval)
				      (- (float initval)))))
				(t 0))))))

(datafun plan-thread until-non-negative
   (deffunc :^ - Thread (plan - Sexp cont - Thread-cont stack - (Lst Obj)
			 _ - Situation env - Typenv)
      (let ((dom (find-domain-in-vartypes env)))
	 (match-let (until-non-negative ?quant ?eltact)
		     plan
	    (let-fun ()
	       (new-Thread
		  (\\ (es - Exec-state)
		     (cond ((eq (!_mode es) ':real)
			    (signal-problem until-non-negative
			       "Get real"))
			   (t
			    (until-thread-cont es quant eltact !()))))
		  plan stack)

	  :where

 (:def until-thread-cont - (Mlv Exec-status Exec-state)
                         (next-es - Exec-state
			  quant eltact - Sexp
			  vals-so-far - (Lst Integer))
    (let ((cur-val (nth-value 1
		       (opt-eval quant (!_sit next-es) !() dom))))
       (cond ((not cur-val)
	      (signal-problem until-non-negative
		 "Can't evaluate " quant)))
       (cond ((>= cur-val 0)
	      (values ':continuing
		      (almost-copy
		         next-es
			 (:active
			    (cons (new-Thread
					cont
					`(after ,plan) stack)
				  !>active)))))
	     ((nums-not-going-anywhere vals-so-far)
	      (values ':failed next-es))
	     (t
	      (funcall
		 (!_continuation
		    (plan->thread
		       eltact 
		       (\\ (es)
			  (until-thread-cont
			     es quant eltact (cons cur-val vals-so-far)))
		       stack
		       (!_sit next-es)
		       env dom))
		 next-es))))))))))

;;; Project until the 'quant' is non-negative
(defproc until-project - (Multvals forced - Boolean
				   final-sit - (~ Situation)
				   adds deletes - (Lst Occasion)
				   frac - Float steps - Fixnum)
	       (mode - Exec-mode sit - Situation act - Action quant - Sexp
		past-sits - (Lst Situation) dom - Domain)
   (let ((orig-val (nth-value 1 (opt-eval quant sit !() dom))))
      (cond ((not orig-val)
	     (signal-problem until-project
		"Can't evaluate " quant)))
      (cond ((>= orig-val 0)
	     (values false sit !() !() 1.0 0))
	    (t
	     (repeat :for ((val orig-val) - Sexp val-okay - Boolean
			   (steps = 1 :by 1) - Fixnum
			   (succ-sit sit) - Situation
			   (forced false) f1 - Boolean
			   (adds !()) (deletes !()) al dl - (Lst Occasion)
			   :collector vals - Number)
		(!= < f1 succ-sit al dl >
		    (discrete-action-force-project
		       mode succ-sit act past-sits dom))
		(cond (f1 (!= forced true)))
		(!= < adds deletes >
		    (add-del-combine adds deletes al dl))
		(!= < val-okay val > (opt-eval quant succ-sit !() dom))
		(cond ((not val-okay)
		       (signal-problem until-project
			  "Can't evaluate " quant)))
	      :until (>= val 0)
	      :result (values forced succ-sit adds deletes 1.0 steps)
	      :collect val
	      :until (nums-not-going-anywhere (!_elements vals))
	      :result (values true false !() !()
			      (/ (- val orig-val)
				 (- (float orig-val)))
			      steps))))))

(deffunc nums-not-going-anywhere - Boolean (vals - (Lst Number))
   (let ((delta0 (car vals)) (numvals (len vals)))
      (and (> numvals 10)
	   (let ((decreases
		    (cons delta0
			  (repeat :for
				  ((delta :in (cdr vals))
				   (prev-delta delta0)
				     - Number)
			   :when (< delta prev-delta)
			   :collect delta
			      (!= prev-delta delta)))))
	      (>= (* 3 (len decreases))
		  numvals)))))

(datafun plan-thread seq
   (deffunc :^ - Thread (plan - Sexp cont - Thread-cont stack - (Lst Obj)
			 _ - Situation env - Typenv)
      (cond ((null (cdr plan))
	     (new-Thread (\\ (es - Exec-state) (funcall cont es))
			 '(null seq) stack))
	    (t
	     (let ((dom (find-domain-in-vartypes env)))
		(let-fun ((:def seq-thread - Thread
					  (acts - (Lst Sexp) es - Exec-state)
			     ;; 'acts' is a non-empty list.
			     (cond ((null (cdr acts))
				    (plan->thread (car acts) cont
						  `(,(car acts) ,@stack)
						  (!_sit es) env
						  (find-domain-in-vartypes env)))
				   (t
				    (plan->thread
				       (car acts)
				       (\\ (es - Exec-state)
					  (seq-next (cdr acts) es))
				       `(,(car acts) ,@stack)
				       (!_sit es)
				       env dom))))
			  (:def seq-next - (Mlv Exec-status Exec-state)
			                 (acts - (Lst Sexp) es - Exec-state)
			     (values ':continuing
				     (almost-copy es
					(:active (cons (seq-thread acts es)
						       !>active))))))
		   (new-Thread
		      (\\ (es - Exec-state)
			 (values ':continuing
				 (almost-copy es
				    (:active (cons (seq-thread (cdr plan) es)
						   !>active)))))
		      plan stack)))))))

(specdecl symno* - Integer)

(datafun plan-thread parallel
   (deffunc :^ - Thread (plan - Sexp cont - Thread-cont stack - (Lst Obj)
			 sit - Situation env - Typenv)
      (let ((dom (find-domain-in-vartypes env)))
	 (cond ((null (cdr plan))
		(new-Thread cont `(after ,plan) stack))
	       ((null (cddr plan))
		(plan->thread (cadr plan) cont stack sit env dom))
	       (t
		(let ((link (make Plan-link
			       (build-symbol (:package false)
					     par-synch- (++ symno*))
			       false nil false false)))
		   (let-fun ()
		      (new-Thread
			    (\\ (es - Exec-state)
			       (values ':continuing
				       (make-inst Exec-state
					  :mode (!_mode es)
					  :forcings (!_forcings es)
					  :steps (!_steps es)
					  :elapsed (!_elapsed es)
					  :active
					     (nconc
						(<# branch-thread (cdr plan))
						(!_active es))
					  :sit (!_sit es)
					  :sit-space (!_sit-space es)
					  :hit (!_hist es)
					  :links (cons (tuple link 0)
						       (!_links es))
					  :env (!_env es)
					  :blocked (!_blocked es))))
			    plan stack)

		    :where

 (:def branch-thread (p)
    (plan->thread
       p
       (\\ (es - Exec-state)
	  (let ((e (assq link (!_env es)))
		- (~ (Lrcd Plan-link Fixnum)))
	     (cond (e
		    (cond ((= (cadr e) 1)
			   (funcall cont es))
			  (t
			   (make-inst Exec-state
			      :mode (!_mode es) :forcings (!_forcings es)
			      :steps (!_steps es) :elapsed (!_elapsed es)
			      :active (!_active es)
			      :sit (!_sit es) :hist (!_hist es)
			      :sit-space (!_sit-space es)
			      :links
				 (link-value-set
				    link (!_env es)
				    #'=
				    (be (Fun Obj Obj)
					(\\ (v - Integer)
					   (+ v 1))))
			      :env (!_env es)
			      :blocked (!_blocked es)))))
		   (t
		    (signal-problem
		       parallel-expander
		       "Unbound Plan-link: " link
		       :% " in " (!_env es))))))
       stack sit env dom)))))))))

(deffunc act->thread - Thread (act - Sexp
			       continuation - Thread-cont
			       stack - (Lst Obj) 
			       sit - (Alt Situation (Const :real))
			       env - Typenv dom - Domain)
   (multi-let (((adefn idefn env1)
		(act-action-defn act dom)))
      (cond ((and (is Action-defn adefn)
		  (!_has-methods (be Action-defn adefn)))
	     (act-method-thread act (be Action-defn adefn) continuation stack sit env))
	    (t
	     ;; Primitive action
	     (new-Thread
		(\\ (es - Exec-state)
		   (cond ((eq (!_mode es) ':real)
			  (action-really-do act es adefn
					    continuation stack sit env))
;;;;			 ((eq (!_mode es) ':zero-step)
;;;;			  (values ':ready
;;;;				  (almost-copy es
;;;;				     (:active
;;;;				         (cons (act->thread act continuaton
;;;;							    stack sit env dom)
;;;;					       !>active))))
			 (t
			  (let ((pr
				 (prim-try-project (!_mode es) 
						   (!_sit es)
						   (!_sit-space es)
						   (<# !_sit (!_hist es))
						   act idefn false env1 eff-varid*
						   dom))
;;;;				(retry (act->thread
;;;;					 act continuation stack sit env dom))
				(continue-after 
				   (new-Thread continuation `(after ,act) stack)))
			     (match-cond pr
				(:? :failed
				   (values ':failed es))
				(:? ?(:\| ?(:& :ready ?stat)
					  (?(:& :open-subgoals ?stat)
					   ?dnf))
				   (values ':ready
					   (almost-copy es
					      (:blocked
					          (cons (make Blockage
							      (make Gate
								 stat
								 dnf)
							      (list
							         (act->thread
								    act continuation
								    stack
								    (be Situation sit)
								    env dom)))
							!>blocked)))))
				(:? (:okay ?sit ?elapsed ?numsteps)
				   (values ':continuing
					   (almost-copy es
					      (:active
					          (cons continue-after
							!>active)
					       :sit (be Situation sit)
					       :elapsed (elapsed-sum
							   !>elapsed elapsed)
					       :steps (+ !>steps numsteps)))))
				(:? (:forced ?num-forcings ?sit ?elapsed ?numsteps)
				   (values ':forced
					   (almost-copy es
					      (:active (cons continue-after
							     !>active)
					       :sit (be Situation sit)
					       :elapsed (elapsed-sum
							   !>elapsed elapsed)
					       :steps (+ !>steps numsteps)
					       :forcings (+ !>forcings num-forcings)))))
				(t
				 (signal-problem act->thread
				    "Indecipherable: " pr)))))))
		`(try-primitive-act ,act)
		stack)))))

;;; The Bdgenv is the result of unifying the action of the 
;;; Internalized-action-defn with 'act'.  Varid for vars in
;;; the Internalized-action-defn is eff-varid*.
(deffunc act-action-defn - (Mlv Causation-defn Internalized-action-defn Bdgenv)
	            (act - Sexp dom - Domain)
  (let-fun ()
     (match-cond act
	?( (?(:\| dur-start dur-stop :& ?ss)
	    (?dfun ?@dargs))
	  (let ((af (find-domain-bdg-val (be CSymbol dfun) dom)))
	     (cond ((is Causation-function af)
		    (let ((ddefn (!_defn af)))
		       (cond ((is Durative-action-defn ddefn)
			      (let ((iddefn
				       (be Internalized-durative-defn
					   (causation-defn-projectable
					      ddefn dom))))
				 (do-unify
				    (cond ((eq ss 'dur-stop)
					   (!_stop-view iddefn))
					  (t (!_start-view iddefn)))
				    ddefn)))
			     (t
			      (signal-problem act-action-defn
				 "In " act ", " `(,dfun ,@dargs)
				 :% " is not a durative-action term")))))
		   (t
		    (signal-problem act-action-defn
		       "In " act ", " dfun
		       " is not a Causation-function")))))
	?( (?(:\| dur-start dur-stop)
	    ?_)
	  (signal-problem act-action-defn
	     "Mal-formed " ss " term: " act))
	?( (?afun ?@_)
	  (let ((af (find-domain-bdg-val (be CSymbol afun) dom)))
  ;;;;	      (out "af = " af " Causation-function? "
  ;;;;		   (is Causation-function af) :%)
	     (cond ((and af
			 (is Causation-function af))
		    (let ((adefn (!_(Causation-function defn) af)))
		       (cond ((is Action-defn adefn)
			      (let ((idefn (be Internalized-action-defn
					       (causation-defn-projectable
						  adefn dom))))
				 (do-unify idefn adefn)))
			     (t
			      (signal-problem act-defn-term-unify
				 "In " act ", " afun
				 :% " is not an action function")))))
		   (t
		    (signal-problem act-defn-term-unify
		       "In " act ", " afun
		       " is not a Causation-function")))))
       (t
	(signal-problem act-defn-term-unify
	   "Ill-formed action: " act)))

     :where

       (:def do-unify - (Multvals defn - Causation-defn
				  idefn - Internalized-action-defn
				  env - Bdgenv)
                (idefn - Internalized-action-defn defn - Causation-defn)
	  (multi-let (((ok e)
		       (unify (!_term idefn)
			      act
			      eff-varid* ground-id* (empty-env))))
	     (cond (ok
		    (values defn idefn e))
		   (t
		    (signal-problem act-defn-term-unify
		       "Action definition fails to unify: " act
		       :% defn)))))))

(defproc prim-try-project - Projection-result
	   (mode - Exec-mode
	    sit - Situation sit-space - Situation-space past-sits - (Lst Situation)
	    act - Sexp idefn - Internalized-action-defn
	    goal - (~ Sexp) env - Bdgenv id - Varid dom - Domain)
	   (ignore goal)
   (let ((uact (uniquify-action act dom)))
      (or (recover-cached-transition mode sit uact sit-space)
	  (let-fun ()
	     (let ((pre 
		      (cond ((!_precond idefn)
			     (bind ((optimist-fn* false))
				(deduce
				   (!_precond idefn) id env sit dom)))
			    (t
			     (list (empty-env))))))
		(cond (pre
		       (cond ((eq mode ':open-subgoals)
			      ':ready)
			     (t
			      (action-precond-project-result
				 (eq mode ':forced)
				 uact idefn (car pre) sit dom))))
		      ((eq mode ':forced)
		       (multi-let (((feas-sit _ _ env)
				    (precond-force-true
					idefn act env id 
					sit past-sits dom)))
			  (action-precond-project-result
			     true uact idefn env feas-sit dom)))
		      (t
		       (tuple (atomconst :open-subgoals)
			      (disjunctive-normal-form (!_precond idefn) true)))))))))

(defproc precond-force-true - (Multvals succ - Situation
					adds dels - (Lst Occasion)
					witness - Bdgenv)
                             (idefn - Internalized-causation-defn
			      act - Sexp
			      env - Bdgenv id - Varid 
			      sit - Situation past-sits - (Lst Situation)
			      sit-space - Situation-space dom - Domain)
   (let ((feas-act
	    (uniquify-action `(make-feasible ,act) dom)))
      (let ((sss (find-old-projection sit feas-act)))
	 (cond (sss
		(with sss
		   (verify !>sit !>adds !>deletes)))
	       (t
		(let-fun ()
		   (let ((new-occs !()) - (Lst Occasion))
		      (!= < new-occs env >
			  (find-assertable-differences
			     (!_condition idefn)
			     env sit past-sits dom))
		      (multi-let (((new-sit adds deletes)
				   (build-new-sit
				      true feas-act
				      new-occs !() dummy-id1* env
				      sit sit-space dom)))
			 (verify
			    (succ-record
			       true sit 0.0 1 feas-act new-sit
			       adds deletes 0.0 !())
			    adds deletes)))
		 :where

		   (:def verify - (Multvals succ - Situation
					    adds dels - (Lst Occasion)
					    witness - Bdgenv)
				(succ - Situation adds dels - (Lst Occasion))
		      (let ((al (deduce (!_condition idefn) id env sit dom)))
			 (cond ((null al)
				(signal-problem precond-force-true
				   "Precond " (!_condition idefn)
				   : % " unprovable after being forced true"))
			       (t
				(values succ adds dels (car al))))))))))))

(specdecl (difs-fill-dbg* true) - Boolean)

(deffunc find-assertable-differences - (Mlv (Lst Occasion) Bdgenv)
	                    (p - Sexp env - Bdgenv
			     sit - Situation past-sits - (Lst Situation)
			     dom - Domain)
   (multi-let (((precond env)
		(safe-varsubst p dummy-id1* env)))
      (dbg-out difs-fill-dbg*
	       "Trying to force " precond " to be true")
      (let ((dp (disjunctive-normal-form precond true))
	    - (Lst (Lst Sexp))
	    result-env - Bdgenv new-occs - (Lst Occasion))
	 (repeat :for ((conj :in dp) - (Lst Sexp)
		       (found-difs false) - Boolean)
	  :result (progn
		     (dbg-save :run-loud dp sit past-sits dom env)
		     (signal-problem find-assertable-differences
			"Unable to complete " precond))
	    (let ((mml (maximal-matches
			  conj !()
			  dummy-id1* env
			  sit dom)))
	       ;; Look for a maximal match whose difs are assertable.
	       (repeat :for ((mm :in mml) - Maximal-match)
		  (cond ((forall (d :in (!_dif mm))
			    (goal-has-assertable-pred (!_goal d)))
			 (letrec ((elim ()
				   (!= < found-difs result-env new-occs >
				       (difs-elim-vars
						   (!_dif mm)
						   (!_constraints mm)
						   (!_subst mm)
						   sit past-sits dom))))					
			    (cond (difs-fill-dbg*
				   (out (:to *error-output*)
				      "Trying difs "
				      (debug-varsubst
				          (!_dif mm) dummy-id1*(!_subst mm))
				      :% (:i> 3) :%
				      (:e (elim))))
				  (t (elim))))))
		:until found-difs))
	  :until found-difs)
	 (values new-occs result-env))))

(deffunc action-precond-project-result - Projection-result
	                     (allow-anomalies - Boolean
			      uact - Action adefn - Internalized-action-defn 
			      bdgs - Bdgenv sit - Situation
			      dom -  Domain)
   (multi-let (((succ _ _ _ _)
		(act-project-given-precond
			  allow-anomalies uact adefn eff-varid* bdgs
			  sit dom true)))
      (cond (succ
	     (make (Lstructure &flag :okay
			       sit - Situation
			       elapsed - Time-int
			       numsteps - Integer)
		   succ 0.0 1))
	    (t
	     ':failed))))

(deffunc act-method-thread - Thread (act - Sexp
				     defn - Action-defn
				     continuation - Thread-cont
				     stack - (Lst Obj)
				     sit - (Alt Situation (Const :real))
				     env - Typenv)
   (let ((dom (find-domain-in-vartypes env)))
      (let-fun ()
	 (new-Thread
	    (\\ (es - Exec-state)
	       (cond ((eq (!_mode es) ':real)
		      (values ':continuing
			      (almost-copy es
				 (:active (cons (find-and-instantiate-method)
						!>active)))))
		     (t
		      (multi-let (((res-status new-es _)
				   (cached-thread-result es act dom)))
			 (cond (res-status
				(values res-status new-es))
			       (t
				(find-and-instantiate-method)))))))
	    act stack)
     :where

 (:def find-and-instantiate-method - Thread ()
   (let ((org (own-rule-group dom)))
      (multi-let (((match meth meth-id meth-env)
		   (action-meths org (!_term defn))))
	 (cond (match
		(meth-instantiate
		   meth meth-id meth-env))
	       (t
		(repeat :for ((bdg :in (domain-get-local-bdgs
					  dom)))
		 :result (signal-problem act->thread
			    "Can't find method for "
			    act)
		 :when (is Rule-group (!_val bdg))
		 :within
		    (multi-let (((match meth meth-id meth-env)
				 (action-meths
				    (be Rule-group (!_val bdg))
				    (!_term defn))))
		       (:continue
			:until match
			:result (meth-instantiate
				   meth meth-id meth-env)))))))))

 (:def action-meths - (Mlv Boolean (~ Internalized-method-defn) Varid (~ Bdgenv))
                    (rg - Rule-group term - Sexp)
     (repeat :for ((rule :in (!_rules rg)))
      :result (values false nil ground-id* nil)
      :when (is Method-defn rule)
      :within
         (let ((imeth (causation-defn-projectable rule dom))
	       (meth-varid (new-Varid)))
	    (multi-let (((ok env)
			 (unify act term act-id* (!_term defn) meth-varid
				(empty-bdgenv))))
	       (:continue
		:until ok
		:result (values true imeth meth-varid env))))))

 (:def meth-instantiate - Thread (imeth - Internalized-method-defn
				  meth-id - Varid meth-env - Bdgenv)
    (multi-let (((exp _)
		 (safe-varsubst (!_expansion imeth) meth-id meth-env)))
       (act->thread exp continuation (cons act stack)
		    sit env dom))))))

(deffunc link-value-set - Link-state
	       (v - Plan-link alist - Link-state
		eql-tester - (Fun Boolean (Obj Obj))
		val-computer - (Fun Obj Obj))
   (let-fun ((search - (Lst Lrcd Plan-link Obj)
	             (al - (Lst (Lrcd Obj Obj)))
	       (cond ((null al)
		      (signal-problem link-value-set
			 "Unbound: " v " in " alist))
		     (t
		      (let ((pair (car al)))
			 (cond ((funcall eql-tester (first pair) v)
				(cons (tuple (car pair)
					     (funcall val-computer (cadr pair)))
				      (cdr al)))
			       (t
				(cons pair (search (cdr al))))))))))
     (search alist)))

(deffunc elapsed-sum - Time-int (elap1 elap2 - Sexp)
   (cond ((and (is Float elap1) (is Float elap2))
	  (be Time-int
	      (+ (be Float elap1) (be Float elap2))))
	 (t
	  (signal-problem elapsed-sum
	     "Attempt to find sum of " elap1 " and " elap2))))