;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: queue.lisp,v 1.1 2004/03/10 04:10:16 dvm Exp $

(depends-on %module/ nisp)

(defnisptype Queue (Structure elts lasttail - (Lst Obj))
   (conser (l - (Lst Obj))
      (cond ((null l)
             (make ^^ '() '()))
            (t (make ^^ l (last l)))))
   (empty - Boolean *integrable (q - Queue)
      (null (!_elts q))))

(defproc enqueue - Void (x - Obj q - Queue)
   (list-enqueue (list x) q))

(defproc list-enqueue - Void (l - (Lst Obj) q - Queue)
   (cond ((not (null l))
          (cond ((!_empty q)
		 (!= (!_elts q) l))
		(t
		 (!= (cdr (!_lasttail q)) l)))
	  (!= (!_lasttail q) (last l)))))

(defproc dequeue - Obj (q - Queue)
   (cond ((!_empty q)
          (error-break dequeue :fatal
             "Attempt to dequeue from empty queue"))
         (t
          (let ((r (car (!_elts q))))
             (cond ((eq (!_elts q) (!_lasttail q))
                    (!= (!_lasttail q) '())))
             (!= (!_elts q) (cdr *-*))
             r))))
                   
