;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: rgprint.lisp,v 1.2 2004/03/10 04:10:17 dvm Exp $

(depends-on %module/ nisp)

(depends-on :at-run-time %optop/ regressmatch dbgrmgraph)

(depends-on :at-compile-time %optop/ decl-dagprint)

(depends-on :at-run-time %hacks/ dagprint)

;;;;(defnisptype Hide-cyclic-es-link (Structure anc - Effort-spec))

(deffunc eff-or-red-children - (Alt (Lst Effort-spec)
				    (Lst Reduction))
	                (x - (Alt Effort-spec Reduction))
   (cond ((is Effort-spec x)
	  (!_children x))
;;;;	 ((is Hide-cyclic-es-link x)
;;;;	  !(Reduction))
	 ((is Reduction x)
	  (!_preconds x))
	 (t
	  (signal-problem eff-or-red-children
	     "Can't find children of " x))))

;;; Is es1 an ancestor of es2?
;;;;(deffunc effort-spec-ancestor - Boolean (es1 es2 - Effort-spec)
;;;;   (exists (red :in (!_parents es2))
;;;;      (or (eq (!_reducee red) es1)
;;;;	  (effort-spec-ancestor es1 (!_reducee red)))))

(specdecl (effnum* 0) - Integer)

(defproc eff-or-red-print - Void (er - Printable-DAG-node)
   (let ((x (!_node er)))
;;;;      (out "Object " x
;;;;	   :% " encountered as node of "
;;;;	   :% 1 er :%)
      (cond ((is Effort-spec x)
;;;;	     (out "Got es"  :%)
	     (effort-spec-display er))
	    ((is Reduction x)
;;;;	     (out "Got red" :%)
	     (out "> "
	        (:q ((!_effective x) "*"))
	        (:q ((!_action x)
		     (!_action x))
		    (t "In previous plan prefix ..."))
	        :% 3 (:q ((eq (!_instances x) '*unknown)
			  "-- instances unknown")
			 ((null (be (Lst Bdgenv) (!_instances x)))
			"-- no instances")
			 (t
			"-- " (len (be (Lst Bdgenv) (!_instances x)))
			      " instances"))
		:%))
	    (t
	     (signal-problem eff-or-red-print
		"Arrived at non-node: " x)))))

(defproc effort-spec-display - Void (er - Printable-DAG-node)
   (let ((es (!_node er)) - Effort-spec)	 
      (let ((cyc (!_cycle er)))
	 (cond ((> cyc 0)
		(!= effnum* (+ *-* 1))
		(!= (!_id er) effnum*)))
	 (out 
	    (:pp-block
	      (:q ((> cyc 0)
		   "[" effnum* " (" cyc ")]"))
	      (:pp-ind :block (cond ((> cyc 0) 3) (t 0)))
	      (!_literal es)
	      1 (!_status (!_l-node es))
	      1 (:pp-nl :linear)
	      (:q ((null (!_constraints es))
		   " -- No constraints" :%)
		 (t
		  " Constraints: " (!_constraints es) :%))
	      (:q ((or (> (!_effort es) 0)
		       (not (memq (!_status (!_l-node es))
				  '(*true *trivial))))
		  " Effort = " (!_effort es) :%))
	      (:q ((> (!_effort es) 0)
		   (:q ((eq (!_actions es) '*in-progress)
			"Actions in progress ")
		       ((eq (!_actions es) '*unknown)
			"Actions unknown ")
		       ((null (!_actions es)) "No actions")
		       (t  "Actions: " (!_actions es)))
		   (:q ((not (atom (!_actions es)))
			:%)
		       (t 1))))
	      :%)))))

(defproc eff-down-print - Void (er - Printable-DAG-node)
   (let ((x (!_node er)))
      (cond ((is Effort-spec x)
	     (out "[" (cdr (!_conjuncts x)) "]"))
	    (t
	     (signal-problem eff-or-red-down-print
		"Encountered twice: " x)))))		   

(defproc eff-up-print - Void (parents stack - (Lst Printable-DAG-node))
			     (ignore stack)
   (cond ((not (null parents))
	  (out 1 (len parents) "^"))))

(defproc eff-cycle-print - Void (er - Printable-DAG-node)
   (let ((anc (!_ancestor er)))
      (let ((ancid (!_id anc)))
	 (out "[^^ " (:q (ancid ancid)
			 (t "??"))
	      "]" :%))))

(defproc rg-indent - Fixnum (i - Fixnum)
   (node-indent-dot-printer i)
   (* 3 i))

(specdecl (rmg-struct-spec*
	     (make DAG-struct-spec #'eff-or-red-children))
	  - DAG-struct-spec
	  (rmg-print-spec*
	     (make-inst DAG-print-spec
		:direct-printer #'eff-or-red-print
		:down-printer #'eff-down-print
		:up-printer #'eff-up-print
		:indent-printer #'rg-indent))
	  - DAG-print-spec)

(defproc rmgraph-print - Void (topnode - Effort-spec)
   (bind ((effnum* 0))
      (dag-print (list topnode)
		 rmg-struct-spec* rmg-print-spec*)))
	     


