(define (domain rockets)
   (:requirements :typing)

   (:types Physob City)
   (:types Rocket Package - Physob)

   (:predicates (at ?p - Physob ?c - City)
		(aboard ?p - Package ?r - Rocket)
		(has-fuel ?r - Rocket))

   (:action load :parameters (?p - Package ?r - Rocket ?c - City)
      :precondition (and (at ?p ?c)
			 (at ?r ?c))
      :effect (and (not (at ?p ?c))
		   (aboard ?p ?r)))

   (:action unload :parameters (?p - Package ?r - Rocket ?c - City)
      :precondition (and (at ?r ?c)
			 (aboard ?p ?r))
      :effect (and (not (aboard ?p ?r))
		   (at ?p ?c)))

   (:action fly :parameters (?r - Rocket ?c1 ?c2 - City)
      :precondition (and (at ?r ?c1)
			 (has-fuel ?r))
      :effect (and (not (at ?r ?c1))
		   (not (has-fuel ?r))
		   (at ?r ?c2))))

(define (problem rocket-test)
   (:domain rockets)

   (:objects zephyr comet - Rocket
	      los-angeles new-york london - City
	      p1 p2 - Package)

   (:init (has-fuel zephyr)    ; - These are always true initially -
	  (has-fuel comet)
	  (at zephyr new-york)
	  (at comet new-york)

	  (at p1 new-york)
	  (at p2 new-york))

   (:goal (at zephyr los-angeles)))

(define (problem rocket-2)
   (:domain rockets)

   (:objects zephyr comet - Rocket
	      los-angeles new-york london - City
	      p1 p2 - Package)

   (:init (has-fuel zephyr)    ; - These are always true initially -
	  (has-fuel comet)
	  (at zephyr new-york)
	  (at comet new-york)

	  (at p1 new-york)
	  (at p2 new-york))

   (:goal (and (at p1 los-angeles)
	       (at p2 london)))

   (:metric minimize (total-steps))
)
	  
   
(define (problem rocket-4)
   (:domain rockets)

   (:objects zephyr comet - Rocket
	      los-angeles new-york london - City
	      p1 p2 p3 p4 - Package)

   (:init (has-fuel zephyr)    ; - These are always true initially -
	  (has-fuel comet)
	  (at zephyr new-york)
	  (at comet new-york)

	  (at p1 new-york)
	  (at p3 new-york)
	  (at p2 new-york)
	  (at p4 new-york))

   (:goal (and (at p1 los-angeles)
	       (at p2 los-angeles)
	       (at p3 london)
	       (at p4 london))))

(define (problem rocket-6)
   (:domain rockets)

   (:objects zephyr comet - Rocket
	      los-angeles new-york london - City
	      p1 p2 p3 p4 p5 p6 - Package)

   (:init (has-fuel zephyr)    ; - These are always true initially -
	  (has-fuel comet)
	  (at zephyr new-york)
	  (at comet new-york)

	  (at p1 new-york)
	  (at p2 new-york)
	  (at p3 new-york)
	  (at p4 new-york)
	  (at p5 new-york)
	  (at p6 new-york))

   (:goal (and (at p1 los-angeles)
	       (at p2 los-angeles)
	       (at p3 los-angeles)
	       (at p4 london)
	       (at p5 london)
	       (at p6 london))))

(define (problem rocket-8)
   (:domain rockets)

   (:objects zephyr comet - Rocket
	      los-angeles new-york london - City
	      p1 p2 p3 p4 p5 p6 p7 p8 - Package)

   (:init (has-fuel zephyr)    ; - These are always true initially -
	  (has-fuel comet)
	  (at zephyr new-york)
	  (at comet new-york)

	  (at p1 new-york)
	  (at p2 new-york)
	  (at p3 new-york)
	  (at p4 new-york)
	  (at p5 new-york)
	  (at p6 new-york)
	  (at p7 new-york)
	  (at p8 new-york))

   (:goal (and (at p1 los-angeles)
	       (at p2 los-angeles)
	       (at p3 los-angeles)
	       (at p4 los-angeles)
	       (at p5 london)
	       (at p6 london)
	       (at p7 london)
	       (at p8 london))))