;-*- Mode: Common-lisp; Package: optop; Readtable: ytools; -*-
(in-package :optop)
;;;$Id: rtree-exec.lisp,v 1.17 2006/01/24 13:33:46 dvm Exp $

;;; This file (rtree-exec) apparently needs to be cmplr-ized.  
;;; BE SURE to add 'watch' to the list of built-in projectables.

(depends-on %module/ nisp)

(depends-on :at-run-time %optop/ optexec)

(deffunc exec-state+feasible-act - Exec-state
	                   (state - Exec-state
		    	    act - Feasible-action-spec
			    skip-first - Boolean
		    	    pp - Plan-prefix
		    	    max-time - Time-int dom - Domain)
   (repeat :for ((act-pp (!_plan-prefix act)))
    :until (eq pp act-pp)
    :result nil
    :until (!_is-initial pp)
       (!= pp (!_prior pp))
    :result (signal-problem exec-state+feasible-act
	       "Can't find plan-prefix for feasible action " act))
   ;; The mode is ':one-step' because we will project one step
   ;; before evaluating.
   (next-exec-state state
      (:mode ':one-step
       :active
         (cons (make Thread
                  (funcall 
		     (rtree-thread-gen 
			   (!_rtree act) skip-first (!_sit pp) dom)
		     no-op-thread-cont*)
		  (make Nonempty-thread-stack
			act empty-thread-stack*))
	       (!_active state)))))

(datafun plan-gen reduction-tree
   (deffunc :^ - Thread-gen (rtplan - Sexp plansit - Situation _ - Typenv)
      (match-let (reduction-tree (?skip-first ?_ ?max-time) ?rtree)
		 rtplan
	 (rtree-thread-gen
	    rtree
	    (not (memq skip-first '(nil false)))
	    plansit (!_domain plansit)))))

;;; We get the 'env' from the Domain, because, although 'rtree' is not
;;; likely to have any free variables, if there are any they're
;;; global.
(deffunc rtree-thread-gen - Thread-gen (rtree - Reduction-tree 
				        skip-first - Boolean
					plansit - Situation dom - Domain)
   (let ((already-done !()) - (Lst Action)
	 (stack (cons rtree stack))
	 (env (domain-place-env dom)))
      (let-fun (;; Returns false if subtree was skipped.
		;; Second val is list of actions executed in order
		;; to achieve preconds.
		(:def tree-thread-gen - (Mlv Thread-gen (Lst Action))
			   (tr - Reduction-Tree
			    skip-first - Boolean
			    already-done - (Lst Action))
                   (control-nest
		      (let* ((achvr (!_achiever tr))
                             (act (!_term achvr)))
                         (cond ((null (!_preconds tr))
                                ;; Leaf
                                (cond ((and (or skip-first
                                                (memq act already-done))
                                       ;; waits always have to be
                                       ;; projected here, because
                                       ;; 'plan-prefix-grow' just
                                       ;; projects the first 'wait'
                                       ;; segment.
                                            (not (matchq
                                                    (?(:\| wait-non-negative
                                                           wait-while)
                                                     ?@_)
                                                    act)))
                                       (values no-op-thread-gen* !()))
                                      (t
                                       (values 
                                          (plan-compile-with-goal-filter
                                             act (!_goal-es rtree))
                                          (list act)))))
			       (t
                                :non-leaf)))
                    :non-leaf
		      (repeat :for ((sub :in (!_preconds tr))
                                      - Reduction-tree
                                    (sk = skip-first :then false)
                                      - Boolean
                                    (tg no-op-thread-gen*)
                                      - Thread-gen
                                    :collector sub-done - Action)
                          (multi-let (((sub-tg sub-tg-acts)
                                       (tree-thread-gen
                                          sub sk already-done)))
                             (sub-acts-collect
                                 sub-tg-acts sub-done already-done)
                             (!= tg
                                 (thread-gen-seq *-* sub-tg)))
                       :result
                         (cond ((eq act 'done)
                                (values tg sub-done))
                               ((member= #'action-subsumed
                                         achvr sub-done)
                                (values
                                   (tree-finish-compile tr tg)
                                   sub-done))
                               ;; -- The idea is that if the
                               ;; regression-graph builder
                               ;; wanted to do a step in order
                               ;; to achieve a precondition of
                               ;; another occurrence of the
                               ;; same step, and this structure
                               ;; survived into the effective
                               ;; subgraph, then the two are
                               ;; not in service of the same
                               ;; goal (L-node).  But all other
                               ;; repetitions are probably
                               ;; there only because we turned
                               ;; a graph into a tree.
                               (t
                                (let ((s (member= #'action-subsumed
                                                  achvr already-done)))
                                   (cond (s
                                          (values tg (cons (car s)
                                                           sub-done)))
                                         (t
                                          (values (tree-finish-compile
                                                     tr tg)
                                                  (cons achvr
                                                        sub-done)))))))))))
	 (nth-value 0 (tree-thread-gen rtree skip-first !()))

       :where
       
 (:def sub-acts-collect - Void (sub-tg-acts - Action
				sub-done already-done
				  - (Collector Action))
    (repeat :for ((sub-act :in sub-tg-acts))
     :when (and (not
		  (member= #'action-subsumed
			   sub (!_elements already-done)))
		(not
		  (member= #'action-subsumed
			   sub (!_elements sub-done))))
       (one-collect sub-done sub-act)
       (one-collect already-done sub-act)))

 (:def tree-finish-compile - Thread-gen
              (rtree - Reduction-tree sub-tg - Thread-gen)
    ;; 'sub-tg' is composite Thread-gen for preconditions of tree.
     (thread-gen-seq
        tg (plan-compile-with-goal-filter
              (!_term (!_achiever rtree))
	      (!_goal-es rtree))))

 (:def plan-compile-with-goal-filter - Thread-gen
		 (act - Action goal-es - Effort-spec)
    (let ((immed-goal (!_literal goal-es)) - Sexp
	  (id (!_varid goal-es)) - Varid
	  (act-tg (cond ((eq (!_term act) 'watch)
			 false)
			(t
			 (plan->thread-gen (!_term act)
					   plansit
					   (domain-place-env dom)))))
	    - (~ Thread-gen))
       (\\ - Thread-cont (c - Thread-cont)
	   (\\ - (Mlv Exec-status Exec-state)
		(estate - Exec-state stack - Thread-stack)
	      (let ((now-instances (deduce immed-goal id !()
					   (!_sit estate) dom)))
		 (dbg-out (and forceproj-dbg*
			       (eq (!_mode estate) ':forced))
		    "Contemplating " act  
		    :% " Purpose: " immed-goal
		    " Already? " (not (null now-instances)))
		 (cond ((eq (!_term act) 'watch)
			;; Do nothing, because the goal should follow from
			;; premises already achieved.
			(values ':continuing
				(cond ((null now-instances)
				       ;; Uh-oh
				       (copy-with-changes estate
					  (:links
					     (link-value-set
					        penalty-link*
						!>links
						(\\ (pen) (+ pen 1))
						false))))
				      (t estate))))
		       ((null now-instances)
			(funcall act-tg
				 (check-goal-after immed-goal id c)))
		       ;; Old forceproj code did the following:
		       ;; If 'immed-goal' had unbound variables,
		       ;; try projecting (unforced) the act or wait,
		       ;; and if it succeeded and made a new instance
		       ;; of 'immed-goal' true, take the new instance.
		       ;; This option has been eliminated here because
		       ;; it is no longer clear what it means to
		       ;; interpose a bit of unforced projecting.
		       ;; So we just take the existing instances --
		       (t c)))))))

 (:def check-goal-after - Thread-cont (immed-goal - Sexp id - Varid
				       c - Thread-cont)
    (\\ - (Mlv Exec-status Exec-state)
	(next-estate - Exec-state next-stack - Thread-stack)
       (let ((goal-achieved
		(and succ-sit
		     (not (null (deduce immed-goal id !()
					(!_sit next-estate)
					dom))))))
	  (funcall c (cond (goal-achieved next-estate)
			   (t
			    (next-exec-state next-estate
			       (:links (cons 
					  (penalty-link* :prev pen
					     (+ pen 1)))))))
		   "next-stack" -- not quite))))
					     
 ;; Note that this is nonsymmetrical.  tr1 is subsumed by tr2 if
 ;; they're the same *or* they're both waits for the same process,
 ;; and tr2 waits for it to be done.
 (:def action-subsumed - Boolean (a1 a2 - Action)
;;;;    (trace-around action-subsumed
;;;;       (:> "(action-subsumed: " a1 :% 4 a2")")
    (or (eq a1 a2)
	(let ((t1 (!_term a1))
	      (t2 (!_term a2)))
	   (and (consp t1) (consp t2)
		(eq (car t1) 'wait-non-negative)
		(eq (car t2) 'wait-while)
		(equal (lastelt t1) (lastelt t2)))))
;;;;       (:< (val &rest _) "action-subsumed: " val))
    ))))

       
 (deffunc new-penalty-binding - (Lrcd Plan-link Obj)
	               (estate - Exec-state fcn - (Fun Number (Number)))
   (tuple penalty-link*
	  (funcall fcn
		   (alref (!_links estate) penalty-link*
			  (signal-problem new-penalty-binding
			     "Penalty not bound in " estate)))))

;;; Apparently no longer used (superseded by handlers in optexec).
(defproc act-or-wait-project - (Mlv (~ Situation)
				    (Alt Time-int (Const *never))
				    Integer)
	                     (forced-mode - Boolean
			      sit - Situation act - Action
			      sit-space - Situation-space dom - Domain)
   (let ((negterm false) (procterm false)- (~ Sexp))
      (matchq ?(:\| (wait-non-negative ?negterm ?procterm)
		   (wait-while ?procterm))
	      (!_term act))
      (cond (procterm
	     (cond (forced-mode
		    (multi-let (((final-sit adds dels elapsed frac)
				 (process-project
				       sit !() procterm negterm
				       sit-space dom)))
		       (!= final-sit
			   (succ-record
			      false sit elapsed 0 act final-sit
			      adds dels frac !() sit-space))
		       (values final-sit elapsed 0)))
		   (t
		    (multi-let (((succ adds deletes elapsed)
				 (wait-project false sit sit-space dom)))
		       (values succ elapsed 0)))))
	    (t
	     (values (nth-value 0
			(project allow-anomalies sit act
				 sit-space dom))
		     0.0 1)))))


